
#include "../melee.h"
#include "../ais.h"

//////////////// States of this AI ///////////////
#define AI_CHASE       1
#define AI_ATTACK      2
#define AI_RUNAWAY     3
//////////////////////////////////////////////////
AI_Player_Arilou::AI_Player_Arilou(Ship *ai) :
  AI_Player(ai) {

 select_state = true;
}

void AI_Player_Arilou::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'
 k.thrust       = true;

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
      Chase(ai_ship->target); break;
    case AI_ATTACK:
      Attack(ai_ship->target); break;
//    case AI_RUNAWAY:
//      Runaway(ai_ship->target, 400.0); break;
    default: break;
 } 

CheckShots();

if (select_state) change_state();
}
void AI_Player_Arilou::ProcessShot(Shot *shot, double range)
{

 if (range >= 300.0) return;
 if (!isTarget(shot)) return;
 
 if (range <= 200.0 && ai_ship->batt >= ai_ship->special_drain){
   k.fire_special = true;
   select_state = true; 
  } else 
  {
   Evade(shot);
   select_state = true; 
  }
}

void AI_Player_Arilou::ProcessLaser(SpaceLine *laser, double range)
{
  if (!isTarget(laser)) return;

  if (ai_ship->batt >= ai_ship->special_drain) 
   k.fire_special = true;
  else
   Evade(laser);

 select_state = true; 
}

void AI_Player_Arilou::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 
 if (range > 300.0 ) 
   state = AI_CHASE;
 else 
  if (ai_ship->batt >= ai_ship->special_drain) 
   state = AI_ATTACK;
//  else
//   state = AI_RUNAWAY;

  select_state = false; 
}
