
#include "../melee.h"
#include "../ais.h"

//////////////// States of this AI ///////////////
#define AI_CHASE       1
#define AI_ATTACK      2
//////////////////////////////////////////////////
AI_Player_Druuge::AI_Player_Druuge(Ship *ai) :
  AI_Player(ai) {

 select_state = true;
}

void AI_Player_Druuge::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'
 k.thrust       = true;

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
      Chase(ai_ship->target); break;
    case AI_ATTACK:
      Attack(ai_ship->target); break;
    default: break;
 } 

CheckShots();

if (select_state) change_state();
}
void AI_Player_Druuge::ProcessShot(Shot *shot, double range)
{

 if (range > 800.0) return;
 if (!isTarget(shot)) return;
 
 select_state = true; 

 if (ai_ship->batt < ai_ship->weapon_drain) {
   k.fire_special = true;
   return;
 }

 if (range < 500.0) {
  if (ai_ship->batt >= ai_ship->weapon_drain)
   k.fire_weapon = true;
  else
    Evade(shot);
 }
}

void AI_Player_Druuge::ProcessLaser(SpaceLine *laser, double range)
{
 if (!isTarget(laser)) return;

 Evade(laser);

 select_state = true; 
}

void AI_Player_Druuge::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 if (range > 800.0 ) 
   state = AI_CHASE;
 else {
  if (ai_ship->batt < ai_ship->weapon_drain) 
   k.fire_special = true;

   state = AI_ATTACK;
 }
  select_state = false; 
}
