
#include "../melee.h"
#include "../ais.h"

//////////////// States of this AI ///////////////
#define AI_CHASE       1
#define AI_ATTACK      2
//////////////////////////////////////////////////
AI_Player_Dumb::AI_Player_Dumb(Ship *ai) :
  AI_Player(ai) {

 select_state = true;
}

void AI_Player_Dumb::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'
 k.thrust       = true;

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_CHASE:
                    Chase(ai_ship->target);
                    break;
    case AI_ATTACK:
                    Attack(ai_ship->target);
                    break;
    default: break;
 } 

 CheckShots();

 if (select_state) change_state();
}

void AI_Player_Dumb::ProcessShot(Shot *shot, double range)
{

 if (range > 500.0) return;

 if (!isTarget(shot) || ai_ship->distance(ai_ship->target)<200.0) return;
 
 if (rand()%3) 
  Evade(shot);
 else 
  Attack((SpaceLocation*)shot);

 select_state = true; 
}

void AI_Player_Dumb::ProcessLaser(SpaceLine *laser, double range)
{
  if (!isTarget(laser) || ai_ship->distance(ai_ship->target)<200.0) return;

  Evade(laser);

 select_state = true; 
}

void AI_Player_Dumb::change_state() 
{

double range = ai_ship->distance(ai_ship->target);

 if (range > 400.0 )  //max zoom
   state = AI_CHASE;
 else 
   state = AI_ATTACK;
 
 select_state = false; 
}
