
#include "../melee.h"
#include "../ais.h"
#include <string.h>

//////////////// States of this AI ///////////////
#define AI_ATTACK      1
#define AI_RUNAWAY     3
#define AI_DEFENCE     4
//////////////////////////////////////////////////
AI_Player_Earthling::AI_Player_Earthling(Ship *ai) :
  AI_Player(ai) {

 int tmp_close[20] = {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1};

 memcpy(close_table, tmp_close, sizeof(int)*20);

 select_state = true;
}

void AI_Player_Earthling::calculate() 
{
 AI_Player::calculate(); //Turn off all 'keys'

 if (ai_ship->target==NULL) {
     Stop();
     return;
  }

   switch (state) {
    case AI_DEFENCE:
      Runaway(ai_ship->target, 300.0);
      k.fire_special = true;
      select_state = true; 
      break;

    case AI_ATTACK:
      Attack(ai_ship->target);
      break;

    case AI_RUNAWAY:
      Runaway(ai_ship->target, 300.0);
      break;
    default: break;
 } 

CheckShots(); 

if (select_state) change_state();
}
////////
void AI_Player_Earthling::ProcessShot(Shot *shot, double range)
{
 if (range>200.0) return; 
 if (!isTarget(shot)) return;

 if (ai_ship->batt >= ai_ship->special_drain) 
  state = AI_DEFENCE;
}

void AI_Player_Earthling::ProcessLaser(SpaceLine *laser, double range)
{
  if (!isTarget(laser)) return;

  if (ai_ship->batt >= ai_ship->special_drain) 
   k.fire_special = true;
  else
   Evade(laser);

 select_state = true; 
}

////////
void AI_Player_Earthling::change_state() 
{

 double range = ai_ship->distance(ai_ship->target);

 if (range > 300.0) {
  if (ai_ship->batt >= ai_ship->weapon_drain) 
   state = AI_ATTACK;
  else    
   state = AI_RUNAWAY;
 } else {
   state = close_table[rand() % 20];
 } 
  select_state = false; 
}