#include "../ais.h"
#include "../melee.h"
#include "../melee/mship.h"

#include <allegro.h>

void ControlKB::load (char *inifile, char *inisection) {
	set_config_file (inifile);
  thrust  = key_num(get_config_string(inisection, "Keyboard_Thrust", 0));
  left    = key_num(get_config_string(inisection, "Keyboard_Left", 0));
  right   = key_num(get_config_string(inisection, "Keyboard_Right", 0));
  fire    = key_num(get_config_string(inisection, "Keyboard_Fire", 0));
  special = key_num(get_config_string(inisection, "Keyboard_Special", 0));
  next = key_num(get_config_string(inisection, "Keyboard_Next_Target", 0));
  prev = key_num(get_config_string(inisection, "Keyboard_Prev_Target", 0));
  close = key_num(get_config_string(inisection, "Keyboard_Close_Target", 0));
	return;
	}
void ControlKB::save (char *inifile, char *inisection) {
	set_config_file (inifile);
	set_config_string(inisection, "Keyboard_Thrust", key_string[thrust]);
	set_config_string(inisection, "Keyboard_Left", key_string[left]);
	set_config_string(inisection, "Keyboard_Right", key_string[right]);
	set_config_string(inisection, "Keyboard_Fire", key_string[fire]);
	set_config_string(inisection, "Keyboard_Special", key_string[special]);
  set_config_string(inisection, "Keyboard_Next_Target", key_string[next]);
  set_config_string(inisection, "Keyboard_Prev_Target", key_string[prev]);
  set_config_string(inisection, "Keyboard_Close_Target", key_string[close]);
	return;
	}
char *ControlKB::getTypeName() {
	return "Keyboard";
	}
int ControlKB::think() {
  int r = 0;
  if (key[thrust]) r |= keyflag::thrust;
  if (key[left]) r |= keyflag::left;
  if (key[right]) r |= keyflag::right;
  if (key[fire]) r |= keyflag::fire;
  if (key[special]) r |= keyflag::special;
  if (key[next]) r |= keyflag::next;
  if (key[prev]) r |= keyflag::prev;
  if (key[close]) r |= keyflag::close;
  return r;
	}
ControlKB::ControlKB(char *name, int id) : Control(name, id) {}

#define KEY_DIALOG_MODIFY 0
#define KEY_DIALOG_OK     1
#define KEY_DIALOG_CANCEL 2
extern char dialog_string[20][80];
DIALOG keyDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,      0,   0,   180,  80,   255,  0,    0,    0,       0,    0,    dialog_string[0], NULL, NULL },
  { d_button_proc,      60,  105,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[1], NULL, NULL },
  { d_button_proc,     360,  105,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[2], NULL, NULL },
  { d_button_proc,     220,   50,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[3], NULL, NULL },
  { d_button_proc,      90,  190,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[4], NULL, NULL },
  { d_button_proc,     320,  190,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[5], NULL, NULL },
  { d_button_proc,      75,  275,  240,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[6], NULL, NULL },
  { d_button_proc,     325,  275,  240,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[7], NULL, NULL },
  { d_button_proc,     200,  320,  240,  40,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[8], NULL, NULL },
  { d_button_proc,      90,  390,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Accept Changes", NULL, NULL },
  { d_button_proc,     330,  390,  200,  50,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Cancel", NULL, NULL },
  { NULL,                0,  0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void ControlKB::setup() {
  int i, t = 0;
  set_dialog_color(keyDialog, makecol(0,0,0), makecol(255,255,255));
	load("scp.ini", getDescription());
  while (true) {
    sprintf ( dialog_string[0], "Keyboard %s:\nSet Your Keys", getDescription());
		sprintf ( dialog_string[1], "Left: %s", key_string[left]);
		sprintf ( dialog_string[2], "Right: %s", key_string[right]);
		sprintf ( dialog_string[3], "Thrust: %s", key_string[thrust]);
		sprintf ( dialog_string[4], "Fire: %s", key_string[fire]);
		sprintf ( dialog_string[5], "Special: %s", key_string[special]);
		sprintf ( dialog_string[6], "Next Target: %s", key_string[next]);
		sprintf ( dialog_string[7], "Prev Target: %s", key_string[prev]);
		sprintf ( dialog_string[8], "Close Target: %s", key_string[close]);
    i = popup_dialog(keyDialog, 1);
		if (i == -1) return;
    if (i <= 8) {
      t = readkey() >> 8;
    }
    if (t == KEY_ESC) i = 7;
    switch (i) {
      case 1: left = t;    break;
      case 2: right = t;   break;
      case 3: thrust = t;  break;
      case 4: fire = t;    break;
      case 5: special = t; break;
      case 6: next = t; break;
      case 7: prev = t; break;
      case 8: close = t; break;
      case 9:  save("scp.ini", getDescription()); return;
      case 10: load("scp.ini", getDescription()); return;
      }
    }
  }


static int active_joystick_users = 0;
void ControlJoy::load (char *inifile, char *inisection) {
	set_config_file (inifile);
	which_joystick = get_config_int(inisection, "Joystick_Which", 0);
	which_joystick = 0;
  thrust  = get_config_int(inisection, "Joystick_Thrust", 0);
  left    = get_config_int(inisection, "Joystick_Left", 0);
  right   = get_config_int(inisection, "Joystick_Right", 0);
  fire    = get_config_int(inisection, "Joystick_Fire", 0);
  special = get_config_int(inisection, "Joystick_Special", 0);
  next = get_config_int(inisection, "Joystick_Next_Target", 0);
  prev = get_config_int(inisection, "Joystick_Prev_Target", 0);
  close = get_config_int(inisection, "Joystick_Close_Target", 0);
	return;
	}
void ControlJoy::save (char *inifile, char *inisection) {
	set_config_file (inifile);
	set_config_int(inisection, "Joystick_Which", which_joystick);
	set_config_int(inisection, "Joystick_Thrust", thrust);
	set_config_int(inisection, "Joystick_Left", left);
	set_config_int(inisection, "Joystick_Right", right);
	set_config_int(inisection, "Joystick_Fire", fire);
	set_config_int(inisection, "Joystick_Special", special);
  set_config_int(inisection, "Joystick_Next_Target", next);
  set_config_int(inisection, "Joystick_Prev_Target", prev);
  set_config_int(inisection, "Joystick_Close_Target", close);
	return;
	}
char *ControlJoy::getTypeName() {
	return "Joystick";
	}
void ControlJoy::initialize() {
	Control::initialize();
	if (active_joystick_users == 0) {
		if (install_joystick(JOY_TYPE_AUTODETECT)) 
			throw ("failed to load joystick driver");
		}
	active_joystick_users += 1;
	poll_joystick();
	if (num_joysticks <= which_joystick) {
		char buffy[80];
		sprintf (buffy, "warning: Joystick %d requested, only %d detected", which_joystick+1, num_joysticks);
		alert (buffy, NULL, NULL, "Resume", NULL, 0, 0);
		}
	return;
	}
void ControlJoy::deinitialize() {
	Control::deinitialize();
	if (active_joystick_users == 0) throw ("ControlJoy::deinitialize -- not initialized");
	active_joystick_users -= 1;
	if (active_joystick_users == 0) {
		remove_joystick();
		}
	return;
	}
static int joykey(int which_joystick, int button) {
	switch (button >> 16) {
		case 0:
			return key[button&255];
		case 1:
			if (which_joystick >= num_joysticks) return 0;
			if ((button&255) >= joy[which_joystick].num_buttons) return 0;
			return joy[which_joystick].button[button&255].b;
		case 2:
			if (which_joystick >= num_joysticks) return 0;
			if (((button>>8)&255) >= joy[which_joystick].num_sticks) return 0;
			if ((button&255) >= joy[which_joystick].stick[(button>>8)&255].num_axis) return 0;
			return joy[which_joystick].stick[(button>>8)&255].axis[button&255].d1;
		case 3:
			if (which_joystick >= num_joysticks) return 0;
			if (((button>>8)&255) >= joy[which_joystick].num_sticks) return 0;
			if ((button&255) >= joy[which_joystick].stick[(button>>8)&255].num_axis) return 0;
			return joy[which_joystick].stick[(button>>8)&255].axis[button&255].d2;
		}
	return 0;
	}
static int joykey_read(int which_joystick) {
	int nb = 0;
	int ns = 0;
	if (which_joystick < num_joysticks) {
		nb = joy[which_joystick].num_buttons;
		ns = joy[which_joystick].num_sticks;
		}
	int r = 0, unpressed = 0;
	int i, j;
	while (!unpressed || !r) {
		poll_keyboard();
		for (i = 0; i < 127; i += 1) if (joykey(which_joystick, i)) r = i;
		poll_joystick();
		for (i = 0; i < nb; i += 1) if (joykey(which_joystick, i+(1<<16))) r = i+(1<<16);
		for (i = 0; i < ns; i += 1) {
			int na = joy[which_joystick].stick[i].num_axis;
			for (j = 0; j < na; j += 1) {
				if (joykey(which_joystick, j+(i<<8)+(2<<16))) r = j+(i<<8)+(2<<16);
				if (joykey(which_joystick, j+(i<<8)+(3<<16))) r = j+(i<<8)+(3<<16);
				}
			}
		if (r == 0) unpressed = true;
		if (key[KEY_ESC]) return 0;
		}
	return r;
	}
static char *joykey_string(int which_joystick, int button) {
	static char buf[160] = "WTF?!?";
	char *t;
	switch (button >> 16) {
		case 0:
			return key_string[button];
		case 1:
			t = buf - 6 + sprintf (buf, "Button %d (none)", button&255);
			if (which_joystick >= num_joysticks) break;
			if ((button&255) >= joy[which_joystick].num_buttons) break;;
			sprintf (t, "(%s)", joy[which_joystick].button[button&255].name);
			break;
		case 2:
			t = buf - 6 + sprintf (buf, "Stick %d: Axi %d: Direction 1 (none)", (button>>8)&255, button & 255);
			if (which_joystick >= num_joysticks) return buf;
			if (((button>>8)&255) >= joy[which_joystick].num_sticks) return buf;
			if ((button&255) >= joy[which_joystick].stick[(button>>8)&255].num_axis) break;
			sprintf (t, "(%s %s)", joy[which_joystick].stick[(button>>8)&255].name, 
					joy[which_joystick].stick[(button>>8)&255].axis[button&255].name);
			break;
		case 3:
			t = buf - 6 + sprintf (buf, "Stick %d: Axi %d: Direction 2 (none)", (button>>8)&255, button & 255);
			if (which_joystick >= num_joysticks) break;
			if (((button>>8)&255) >= joy[which_joystick].num_sticks) break;
			if ((button&255) >= joy[which_joystick].stick[(button>>8)&255].num_axis) break;
			sprintf (t, "(%s %s)", joy[which_joystick].stick[(button>>8)&255].name, 
					joy[which_joystick].stick[(button>>8)&255].axis[button&255].name);
			break;
		}
	return buf;
	}

#define JOY_DIALOG_MODIFY 0
#define JOY_DIALOG_OK     1
#define JOY_DIALOG_CANCEL 2
DIALOG joyDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    100,   0,   180,  60,   255,  0,    0,    0,       0,    0,    dialog_string[0], NULL, NULL },
  { d_button_proc,     100,   80,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[1], NULL, NULL },
  { d_button_proc,     100,  120,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[2], NULL, NULL },
  { d_button_proc,     100,  160,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[3], NULL, NULL },
  { d_button_proc,     100,  200,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[4], NULL, NULL },
  { d_button_proc,     100,  240,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[5], NULL, NULL },
  { d_button_proc,     100,  280,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[6], NULL, NULL },
  { d_button_proc,     100,  320,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[7], NULL, NULL },
  { d_button_proc,     100,  360,  500,  30,   255,  0,    0,    D_EXIT,  0,    0,    dialog_string[8], NULL, NULL },
  { d_button_proc,     120,  400,  200,  60,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Accept Changes", NULL, NULL },
  { d_button_proc,     340,  400,  200,  60,   255,  0,    0,    D_EXIT,  0,    0,    (void*)"Cancel", NULL, NULL },
  { NULL,                0,  0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void ControlJoy::setup() {
  int i, t = 0;
  set_dialog_color(joyDialog, makecol(0,0,0), makecol(255,255,255));
	load("scp.ini", getDescription());
  while (true) {
    sprintf ( dialog_string[0], "Joystick %s:\nSet Your Buttons", getDescription());
		sprintf ( dialog_string[1], "Left: %s", joykey_string(which_joystick, left));
		sprintf ( dialog_string[2], "Right: %s", joykey_string(which_joystick, right));
		sprintf ( dialog_string[3], "Thrust: %s", joykey_string(which_joystick, thrust));
		sprintf ( dialog_string[4], "Fire: %s", joykey_string(which_joystick, fire));
		sprintf ( dialog_string[5], "Special: %s", joykey_string(which_joystick, special));
		sprintf ( dialog_string[6], "Next Target: %s", joykey_string(which_joystick, next));
		sprintf ( dialog_string[7], "Prev Target: %s", joykey_string(which_joystick, prev));
		sprintf ( dialog_string[8], "Close Target: %s", joykey_string(which_joystick, close));
    i = popup_dialog(joyDialog, 1);
		if (i == -1) return;
    if (i <= 8) t = joykey_read(which_joystick);
    if (t == KEY_ESC) i = 7;
    switch (i) {
      case 1: left = t;    break;
      case 2: right = t;   break;
      case 3: thrust = t;  break;
      case 4: fire = t;    break;
      case 5: special = t; break;
      case 6: next = t; break;
      case 7: prev = t; break;
      case 8: close = t; break;
      case 9:  save("scp.ini", getDescription()); return;
      case 10: load("scp.ini", getDescription()); return;
      }
    }
  }
int ControlJoy::think() {
	int r = 0;
	poll_joystick();
	if (joykey(which_joystick, thrust)) r |= keyflag::thrust;
	if (joykey(which_joystick, left)) r |= keyflag::left;
	if (joykey(which_joystick, right)) r |= keyflag::right;
	if (joykey(which_joystick, fire)) r |= keyflag::fire;
	if (joykey(which_joystick, special)) r |= keyflag::special;
	if (joykey(which_joystick, next)) r |= keyflag::next;
	if (joykey(which_joystick, prev)) r |= keyflag::prev;
	if (joykey(which_joystick, close)) r |= keyflag::close;
	return r;
	}
ControlJoy::ControlJoy(char *name, int id) : Control(name, id), which_joystick(0) {
	return;
	}
