
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <allegro.h>

#include "../melee.h"
#include "../libs.h"
#include "../scp.h"
#include "../frame.h"
#include "../ais.h"

#include "mmain.h"
#include "mview.h"
#include "mcontrol.h"
#include "mcbodies.h"
#include "mshppan.h"
#include "mship.h"
#include "mnet.h"

NetTCP net;

// Define global space frame
SpaceFrame *spaceFrame = NULL;
// Define global planet object
Planet *spacePlanet = NULL;
SpaceSprite *planetSprite[3];


#define MSECS_PER_TIC								5
#define MSECS_PER_FPS								200
int frame_time;
static int maximum_msecs_per_render;
static int msecs_per_physics;
double turbo;
int time_ratio; //1000 milliseconds / SC2 framerate
double distance_ratio;
int scale_frames(double value) {
	return (int)((value + 1) * time_ratio);
	}
double scale_turning (double turn_rate) {
//  turn_rate = 20.0 / ((turn_rate + 1.0) * 5.0);	
	return (360. / 16) / (turn_rate + 1.0) / time_ratio;
	}
double scale_velocity (double velocity) {
//  velocity = velocity / 7.5;
//velocity = x sc2pixels / sc2frame
//velocity = y twpixels / twframe
//velocity = x (1. / 1600) / (50ms)
//velocity = y (1. / 3840) / (1ms)
// y = x * (3840 / 1600) / 50
// WTF????
	return velocity * distance_ratio / time_ratio;
	}
double scale_acceleration (double acceleration, double raw_hotspot_rate) {
//  accel_rate = accel_rate / 100.0;
	return acceleration * distance_ratio / (1 + raw_hotspot_rate) / time_ratio / time_ratio; 
	}
double scale_range (double range) {
	return range * 40;
	}

#define time_buf_len 4
volatile int total_physics[time_buf_len];
volatile int total_renders[time_buf_len];
volatile int timed_physics[time_buf_len];
volatile int timed_renders[time_buf_len];
volatile int timing_pos = 0;

int actual_time = 0;
int game_time;
int play_mode;
int hero;
int first_local_player;
int num_local_players;
int num_players;
char      **name = NULL;
Control   **control = NULL;
ShipPanel **panel = NULL;

JGMOD *meleeVictory;
JGMOD *natural_victory;

Frame *space;
Frame *radar;

shiptype_type *shiptype = NULL;
int num_shiptypes = 0;

char *fleet_id[MAX_FLEET_SIZE];
char *fleet_name[MAX_FLEET_SIZE];

char fleet_title[80];
int  fleet_size = 0;
int  fleet_cost = 0;

int debug_value = 0;

char strEmptySlotID[] = "?????";
char strEmptySlotName[] = "[Empty slot]";

DATAFILE *melee = NULL;
DATAFILE *scppal = NULL;

int melee_paused = 0;

static int next_fps_time;


static volatile int melee_time;

void melee_timer() {
	if (!melee_paused) melee_time += MSECS_PER_TIC;
	actual_time += MSECS_PER_TIC;
	}
END_OF_FUNCTION(melee_timer);

void fps_proc() {
	timing_pos += 1;
	if (timing_pos == time_buf_len) timing_pos = 0;
	total_physics[timing_pos] = 0;
	total_renders[timing_pos] = 0;
	timed_physics[timing_pos] = 0;
	timed_renders[timing_pos] = 0;
	}
END_OF_FUNCTION(fps_proc);

char *selectListboxGetter(int index, int *list_size);


static DIALOG help_dialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_box_proc,        80,  50,    480,  400,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_button_proc,     85,  55,    470,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void *)"Exit help screen" , NULL, NULL },
  { d_textbox_proc,    85,  90,    470,  355,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};

void show_help() {
	int i;
	char buffy[100000];
	suspend_melee();
	PACKFILE *f;
	f = pack_fopen ("readme.txt", F_READ);
	if (!f) strcpy(buffy, "Failed to load readme.txt");
	else {
		i = pack_fread (buffy, 99999, f);
		pack_fclose(f);
		buffy[i] = 0;
		}
	set_dialog_color(help_dialog, pallete_color[0], pallete_color[15]);
	help_dialog[2].dp = (void *) buffy;
	popup_dialog(help_dialog, 1);
	resume_melee();
	return;
	}


void       load_ship_data(int index);
void       free_ships(int ship1, int ship2);
ShipPanel *select_ship(int player, int index);
int        ship_idtoindex(const char *id_str);

void suspend_melee();
void resume_melee();
void save_screen_shot();
void play_frame() ;
void animate_frame() ;


int *total_fleet;
int *slot;
int *ship;

char chat_buf[256];
int chat_len = 0;
int chat_on = 0;
int show_fps = 0;
int antia_on;



int gamestate_checksum = 0;
int desynched_frame = -1;

void calculate_gamestate_checksum() {
	int i;
	double g = 0;
	SpaceLocation *f;
	for (i = 0; i < SPACE_LAYERS; i += 1) {
		f = spaceFrame->getFirstObject (i);
		while (f) {
			g += f->normal_x ();
			f = f->next;
			}
		}
	gamestate_checksum = (int(g * 256) + tw_random_peek()) & 255;
	return;
	}

void choose_new_ships() {
	int i;
	message.out("Selecting ships...", 2000);
	animate_frame();
	suspend_melee();
	for (i = 0; i < num_players; i += 1) if ((!panel[i] || !panel[i]->ship) && (slot[i] != -1)) {
		if (panel[i]) delete panel[i];
		panel[i] = NULL;
		char tmp[40];
		sprintf (tmp, "Player%d", i+1);
		load_fleet("tmp.ini", tmp);
		clear_fleet_slot(slot[i]);

		save_fleet("tmp.ini", tmp);
		load_fleet("tmp.ini", tmp);
		if (fleet_size != 0) {
			
			slot[i] = control[i]->choose_ship(i, total_fleet[i]);
//endian
			tw_log(LOG_PLAYER_SHIPS + i, &slot[i], 1);
			tw_unlog(LOG_PLAYER_SHIPS + i, &slot[i], 1);
			ship[i] = ship_idtoindex(fleet_id[slot[i]]);
			panel[i] = select_ship(i, ship_idtoindex(fleet_id[slot[i]]));
			panel[i]->ship->locate();
			control[i]->select_ship(panel[i]->ship, panel[i]->ship->data->type->id);
			for (int t = 0; t < num_players; t += 1) {
				if (t != i) {
					if (panel[t] && panel[t]->ship) control[i]->add_target(panel[t]->ship);
					control[t]->add_target(panel[i]->ship);
					}
				}
			}
		else {
			slot[i] = -1;
			char tmp[80];
			sprintf(tmp, "%s has no ships remaining", name[i]);
			if(alert(tmp, NULL, NULL, "&Resume game", "&Abort game", 'r', 'a') == 2)
				throw "Quit from keyboard (no ships remaining)";
			}
		}
	resume_melee();
	message.out("Finished selecting ships...", 2500);
	animate_frame();
	return;
	}

void play_frame() {
	int of = melee_time;
	int i;

	poll_keyboard();
	if (of < msecs_per_physics) return;

	for (i = 0; i < num_players; i += 1) {
    control[i]->calculate();
		if (control[i]->ship) {
//endian
			tw_log   (LOG_PLAYER_KEYS+i, &(control[i]->ship->nextkeys), 1);
			tw_unlog (LOG_PLAYER_KEYS+i, &(control[i]->ship->nextkeys), 1);
			}
		poll_keyboard();
		}


	spaceFrame->calculate();
	spaceFrame->collide();

	for (i = 0; i < num_players; i += 1) {
    if (panel[i]) {
			panel[i]->calculate();
			if (panel[i]->ship && !panel[i]->ship->phased_in) {
				panel[i]->ship->calculate();
				if (panel[i]->ship->phased_in) spaceFrame->addSpaceObject(panel[i]->ship);
				}
			}
		}

	view->calculate();
	calculate_gamestate_checksum();
	char local_checksum  = gamestate_checksum & 0xff;
	char global_checksum = gamestate_checksum & 0xff;
	tw_log   ( LOG_CHECKSUM1, &local_checksum, 1);
	tw_log   ( LOG_CHECKSUM2, &global_checksum, 1);
	tw_unlog ( LOG_CHECKSUM1, &local_checksum, 1);
	tw_unlog ( LOG_CHECKSUM2, &global_checksum, 1);

	if (local_checksum != global_checksum) {
		if (desynched_frame == -1) {
			desynched_frame = game_time;
			message.print(1800000, 12, 0, "GAME HAS DESYNCHRONIZED (time = %d)", desynched_frame);
			}
		palette_color[0] = random();
		}

	if (melee_time > of + 50) melee_time = of + msecs_per_physics;
	timed_physics[timing_pos] += melee_time - of;
	total_physics[timing_pos] += 1;
	melee_time -= msecs_per_physics;
	game_time += frame_time;
	if (key[KEY_F4] && (melee_time < maximum_msecs_per_render)) melee_time += msecs_per_physics * 4 / 5;
	return;
	}

void animate_frame () {
	int of = melee_time;
	if (keypressed()) {
		int k = readkey();
		switch (k >> 8) {
			case KEY_ESC:
			case KEY_F10:
				suspend_melee();
				font = desktop_font;
				if(alert("Game is paused", NULL, NULL, "&Abort game", "&Resume playing", 'a', 'r') == 1)
					throw "Quit from keyboard (game aborted)";
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F1: // help
				show_help();
				break;
			case KEY_F3: // switch hero
				hero += 1;
				if (hero >= first_local_player + num_local_players) hero = first_local_player;
				message.print(1000, 15, 0, "Player %d (min %d, max %d)", hero+1, 
						first_local_player+1, first_local_player+num_local_players);
				break;
			case KEY_F5: // view fleets
				message.print(1000, 15, 0, "fleet viewing not yet implemented");
				break;
			case KEY_F6: // send message
				chat_len = 0;
				chat_buf[0] = '\0';
				chat_on = 1;
				break;
			case KEY_F7: // time precision mode
				if (frame_time < 15) {
					frame_time = 25;
					message.out("Physics set to 40 / second");
					}
				else {
					frame_time = 10;
					message.out("Physics set to 100 / second");
					}
				msecs_per_physics = (int)(frame_time / turbo + 0.5);
				break;
			case KEY_F9: // add planet
				message.out("MUHAHAHAHAHA!!!!", 5000, 12);
				spaceFrame->addSpaceObject(new Planet(planetSprite[random()%3]))->
						translate(random() % (int)X_MAX, random() % (int)Y_MAX);
				break;
			default:
				if (chat_on) {
					if ((k >> 8) == KEY_ENTER) {
						char buf[512];
						sprintf (buf, "Player %d: %s", hero+1, chat_buf);
						message.print(3000, 13, 1, "Player %d: %s", hero+1, chat_buf);
						chat_on = 0;
						}
					else if (k & 255) {
						if ((k & 255) == 8) {
							if (chat_len > 0) {
								chat_len -= 1;
								chat_buf[chat_len] = 0;
								}
							}
						else {
							chat_buf[chat_len] = k & 255;
							if (chat_len < 255) chat_len += 1;
							chat_buf[chat_len] = 0;
							}
						}
					}
				break;
			case KEY_F2: // options
				suspend_melee();
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				destroy_bitmap (space->child); space->child = NULL;
				destroy_bitmap (space->frame); space->frame = NULL;
				destroy_bitmap (radar->child); radar->child = NULL;
				change_options();
				view_x = screen_x - PANEL_WIDTH * (int)ceil(num_players / (double) PANELS_PER_COLUMN);
				view_y = screen_y;
				space->frame = create_bitmap (view_x, view_y);
				space->child = create_sub_bitmap (screen, 0, 0, view_x, view_y);
				radar->child = create_sub_bitmap (screen, screen_x-60, screen_y-52, 56, 48);
				font = (FONT *)(scppal[SCPPAL_FONT].dat);
				resume_melee();
				break;
			case KEY_F12:
				show_fps = !show_fps;
				break;
			case KEY_F11:
				suspend_melee();
				save_screen_shot();
				resume_melee();
				break;
			}
		}
	if (next_fps_time <= game_time) {
		next_fps_time = game_time + MSECS_PER_FPS;
		if (chat_on) {
			message.print(MSECS_PER_FPS, 15, 0, "say: %s", chat_buf);
			}
		if (show_fps) {
			int a, b, c, d;
			a = b = 0;
			c = d = 0;
			for (int i = 0; i < time_buf_len; i += 1) if (i != timing_pos) {
				a += timed_physics[i];
				b += timed_renders[i];
				c += total_physics[i];
				d += total_renders[i];
				}
			if (!c) c = 1;
			if (!d) d = 1;
			message.print(MSECS_PER_FPS, 6, 0, "   physics: %.1f ms  ", double(a) / c);
			message.print(MSECS_PER_FPS, 6, 0, "   renders: %.1f ms  ", double(b) / d);
			message.print(MSECS_PER_FPS, 6, 0, "   Frames Per Second: %d  ", d * 1000 / MSECS_PER_FPS / (time_buf_len-1));
			message.print(MSECS_PER_FPS, 6, 0, "   debug: %d  ", debug_value);
			message.print(MSECS_PER_FPS, 6, 0, "   pending: %d  ", melee_time);
			}
		}
	view->animate();
	timed_renders[timing_pos] += (melee_time - of);
	total_renders[timing_pos] += 1;
	return;
	}

int melee_state = -1;
void melee_init ( int _play_mode) {
	int i;
	char tmp[80];
	const char *t;
  LOCK_FUNCTION(melee_timer);
  LOCK_VARIABLE(melee_time);
  LOCK_VARIABLE(melee_paused);

  LOCK_FUNCTION(fps_proc);
  LOCK_VARIABLE(total_physics);
  LOCK_VARIABLE(total_renders);
  LOCK_VARIABLE(timed_physics);
  LOCK_VARIABLE(timed_renders);
  LOCK_VARIABLE(timing_pos);

	play_mode = _play_mode;
	gamestate_checksum = 0;
	desynched_frame = -1;
  game_time = 0;
	melee_time = 0;
	next_fps_time = 0;
	for (i = 0; i < time_buf_len; i += 1) {
		total_physics[i] = 0;
		total_renders[i] = 0;
		timed_physics[i] = 0;
		timed_renders[i] = 0;
		}
	melee = load_datafile("melee.dat");
	if(!melee) throw("Error loading melee data\n");
	PANELS_PER_COLUMN = (screen_y - 80) / PANEL_HEIGHT;
	
	asteroidSprite          = new SpaceSprite(&melee[MELEE_ASTEROID], ASTEROID_FRAMES);
	asteroidExplosionSprite = new SpaceSprite(&melee[MELEE_ASTEROIDEXPLOSION], ASTEROIDEXPLOSION_FRAMES);
	hotspotSprite           = new SpaceSprite(&melee[MELEE_HOTSPOT], HOTSPOT_FRAMES);
	kaboomSprite            = new SpaceSprite(&melee[MELEE_KABOOM], KABOOM_FRAMES);
	sparkSprite             = new SpaceSprite(&melee[MELEE_SPARK], SPARK_FRAMES);
	natural_victory = (JGMOD*) (melee[MELEE_PLANET+3].dat);

	gui_bg_color = pallete_color[0];
	gui_fg_color = pallete_color[15];
	text_mode(-1);

	font = (FONT *)(scppal[SCPPAL_FONT].dat);

/////////////////////////////////
	if (tw_log_start() < 0) return;
/////////////////////////////////

	i = time(NULL);
//endian (disk format)
	tw_log   (LOG_MAIN, &i, 4);
	tw_unlog (LOG_MAIN, &i, 4);
	tw_random_seed(i);	

	tw_log_file("scp.ini");
	tw_unlog_file("scp.ini");

//use remote .ini file
	time_ratio = (int)(1000. / get_config_float ("SCP", "SC2FrameRate", 20));
	distance_ratio = (3840. / get_config_float ("SCP", "SC2TotalDistance", 8000));
	frame_time = (int)(1000. / get_config_float ("SCP", "TicRate", 40) + 0.5);
	turbo = get_config_float("SCP", "Turbo", 1);
	msecs_per_physics = (int)(frame_time / turbo + 0.5);
	maximum_msecs_per_render = 
			(int)(1000. / get_config_float("SCP", "MinimumFrameRate", 10) + 0.5);

	set_config_file("tmp.ini");
	num_players = get_config_int("game", "NumPlayers", 0);
	first_local_player = get_config_int("game", "FirstLocalPlayer", 0);
	num_local_players = get_config_int("game", "NumLocalPlayers", 0);
	if (!num_players) return; else hero = first_local_player;
	control = new Control*[num_players];
	name    = new char*[num_players];
	for (i = 0; i < num_players; i += 1) {
		set_config_file("tmp.ini");
		sprintf (tmp, "Player%d", i+1);
		t = get_config_string(tmp, "Type", NULL);
		name[i] = strdup(get_config_string(tmp, "Name", "nameless"));
		control[i] = getController(control2number(t), name[i], i);
		sprintf(tmp, "Config%d", get_config_int(tmp, "Config", 0));
		control[i]->load("scp.ini", tmp);
		}
	panel = new ShipPanel*[num_players];
	for (i = 0; i < num_players; i += 1) {
		control[i]->initialize();
		panel[i] = NULL;
		}
	total_fleet = new int[num_players];
	slot = new int[num_players];
	ship = new int[num_players];
	for (i = 0; i < num_players; i += 1) {
		sprintf (tmp, "Player%d", i+1);
		load_fleet("tmp.ini", tmp);
		total_fleet[i] = fleet_cost;
		slot[i] = -2;
		ship[i] = -1;
		}

	view_x = screen_x - PANEL_WIDTH * (int)ceil(num_players / (double) PANELS_PER_COLUMN);
	view_y = screen_y;
	space = new Frame(0, 0, view_x, view_y, MAX_SPACE_ITEMS);
	radar = new Frame(screen_x - 60, screen_y - 52, 56, 48, MAX_RADAR_ITEMS);
	view->init();

	spaceFrame = new SpaceFrame(space, radar, SPACE_LAYERS);
	planetSprite[0] = new SpaceSprite(&melee[MELEE_PLANET + 0], 1);
	planetSprite[1] = new SpaceSprite(&melee[MELEE_PLANET + 1], 1);
	planetSprite[2] = new SpaceSprite(&melee[MELEE_PLANET + 2], 1);
	spacePlanet = new Planet(planetSprite[random() % 3]);
	spaceFrame->addSpaceObject(spacePlanet);
	for (i = 0; i < NUM_ASTEROIDS; i += 1) spaceFrame->addSpaceObject(new Asteroid());

	set_volumes();
	draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat), SCREEN_W - 64, SCREEN_H - 80);

	install_int(melee_timer, MSECS_PER_TIC);
	install_int(fps_proc, MSECS_PER_FPS);

	melee_state = 0;
	return;
	}

void melee_end() {
	int i;
	tw_log_end();
	remove_int(melee_timer);
	remove_int(fps_proc);
	for (i = 0; i < num_players; i += 1) {
		control[i]->deinitialize();
		delete control[i];
		control[i] = NULL;
		delete name[i];
		name[i] = NULL;
		if (panel[i] != NULL) delete panel[i];
		panel[i] = NULL;
		}
	delete control;
	delete name;

	view->deinit();

  delete asteroidSprite;					asteroidSprite = NULL;
  delete asteroidExplosionSprite;	asteroidExplosionSprite = NULL;
  delete hotspotSprite;						hotspotSprite = NULL;
  delete kaboomSprite;						kaboomSprite = NULL;
  delete sparkSprite;							sparkSprite = NULL;

  delete spaceFrame;							spaceFrame = NULL;
	spacePlanet = NULL;

  delete radar;										radar = NULL;
  delete space;										space = NULL;

#ifndef _DEBUG
	delete_file("tmp.ini");
#endif
  free_ships(-1, -1);
  unload_datafile(melee); melee = NULL;
	set_volumes();
	message.flush();

	melee_state = -1;
	return;
	}

void play_melee( int _play_mode) {
	melee_init(_play_mode);
	if (melee_state < 0) return;
	int last_draw_time = game_time;
	int victory_time = 0;
	try {
		choose_new_ships();
		play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);
		meleeVictory = (JGMOD *)(melee[MELEE_MUSIC].dat);
		while(true) {
			if (!victory_time) {
				if (meleeVictory != (JGMOD *)(melee[MELEE_MUSIC].dat)) {
					if (meleeVictory) play_mod(meleeVictory, FALSE);
					victory_time = game_time + 3500;
					}
				}
			else if (game_time >= victory_time) {
				suspend_melee();
				victory_time = 0;
				meleeVictory = (JGMOD *)(melee[MELEE_MUSIC].dat);
				choose_new_ships();
	//    free_ships(ship1, ship2);
				resume_melee();
				}
			if(!is_mod_playing()) {
				play_mod((JGMOD *)(melee[MELEE_MUSIC].dat), TRUE);
				}
			play_frame();
			if (melee_time > 200) melee_time = 200;
			if (key[KEY_ESC] || (game_time > last_draw_time + maximum_msecs_per_render) ||
					(melee_time < msecs_per_physics)) {
				animate_frame();
				last_draw_time = game_time;
				}
			}
		}
	catch (char *string) {
		if (false) ;
		else if (!strncmp(string, "quit", 4)) ;
		else if (!strncmp(string, "Quit", 4)) ;
		else throw ;
		}
	melee_paused = 0;
	stop_mod();
	if(meleeVictory)
		play_mod(meleeVictory, FALSE);
	melee_end();
	return;
	}

void suspend_melee() {
	gui_bg_color = pallete_color[15];
	gui_fg_color = pallete_color[0];
	melee_paused += 1;
	}

void resume_melee() {
	int i;
	if (!melee_paused) throw ("error - bad unpause");
	if (spaceFrame) {
		text_mode(-1);
		clear_to_color(screen, pallete_color[0]);
		rectfill (screen, view_x, 0, screen_x-1, screen_y-1, pallete_color[8]);
		if (space) space->add_box(0, 0, view_x, view_y);
		if (radar) radar->add_box(0, 0, 56, 48);
		for (i = 0; i < num_players; i += 1) {
			if (panel && (panel[i]) && (panel[i]->exists())) panel[i]->refresh(i);
			}
		if (melee) draw_rle_sprite(screen, (RLE_SPRITE *)(melee[MELEE_PANEL].dat),
				SCREEN_W - 64, SCREEN_H - 80);
		}
	melee_paused -= 1;
	return;
	}

void save_screen_shot()
{
  static int shot_index = 0;

  BITMAP *bmp;
  PALLETE pal;

  char path[80];

  get_pallete(pal);
  bmp = create_bitmap(SCREEN_W, SCREEN_H);
  acquire_screen();
  blit(screen, bmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
  release_screen();

  if(shot_index < 10000) {
    sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    while(exists(path)) {
      shot_index++;
      sprintf(path, "scrshots/shot%04d.pcx", shot_index);
    }
  } else
    sprintf(path, "scrshots/");

  font = desktop_font;
  if(file_select("Save screen shot", path, "BMP;PCX;TGA"))
    save_bitmap(path, bmp, pal);

  destroy_bitmap(bmp);
  font = (FONT *)(scppal[SCPPAL_FONT].dat);
}
/*

#define VICTORY_DIALOG_TITLE     0
#define VICTORY_DIALOG_LIST      1
#define VICTORY_DIALOG_PLAYERBOX 2
#define VICTORY_DIALOG_PLAYER    3
#define VICTORY_DIALOG_CONTINUE  4

void show_fleet(int player, char *fleet_file, int fleet_total, int slot)
{
  load_fleet(fleet_file, "Fleet");

  sprintf(selectPlayer, "Player %d Fleet", player+1);

  sprintf(selectTitleString, "%s\n%d of %d points", fleet_title, fleet_cost, fleet_total);
  victoryDialog[VICTORY_DIALOG_LIST].d1 = slot;
  do_dialog(victoryDialog, VICTORY_DIALOG_CONTINUE);
}*/

char shipSelection[80];
char *shipListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = num_shiptypes;
    return NULL;
  } else {
    sprintf(shipSelection, "%s %d", shiptype[index].name, shiptype[index].cost);
    return shipSelection;
  }
}

void init_fleet()
{
  int i;

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    fleet_id[i] = strEmptySlotID;
    fleet_name[i] = strEmptySlotName;
  }

  fleet_size = 0;
  fleet_cost = 0;
  sprintf(fleet_title, "Untitled");
}

void select_fleet_slot(int slot, int ship_index)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    fleet_size++;
  else
    fleet_cost -= shiptype[ship_idtoindex(fleet_id[slot])].cost;

  fleet_cost += shiptype[ship_index].cost;

  fleet_id[slot] = shiptype[ship_index].id;
  fleet_name[slot] = shiptype[ship_index].name;
}

void clear_fleet_slot(int slot)
{
	if (slot < 0) return;
  if(fleet_id[slot] == strEmptySlotID)
    return;

  fleet_cost -= shiptype[ship_idtoindex(fleet_id[slot])].cost;
  fleet_id[slot] = strEmptySlotID;
  fleet_name[slot] = strEmptySlotName;
  fleet_size--;
}

void save_fleet(char *filename, char *section)
{
  int i, count = 0;
  char slot_str[8];

  if (filename) set_config_file(filename);

  for(i = 0; i < MAX_FLEET_SIZE; i++) {
    if(strcmp(fleet_id[i], strEmptySlotID) != 0) {
      sprintf(slot_str, "Slot%d", count);
      set_config_string(section, slot_str, fleet_id[i]);
      count++;
    }
  }

  for(i = count; i < MAX_FLEET_SIZE; i++) {
    sprintf(slot_str, "Slot%d", i);
    set_config_string(section, slot_str, NULL);
  }

  set_config_int(section, "Size", count);
  set_config_string(section, "Title", fleet_title);

  // to force saved SCF files to be written
  set_config_file("scp.ini");
}

int ship_idtoindex(const char *id_str)
{
  int i = 0, found = FALSE;

  #ifdef SCP_DEBUG
  fprintf(debug_file, "- ShipID to index %s\n", id_str);
  fflush(debug_file);
  #endif

  if(id_str == NULL) return -1;

  while((i < num_shiptypes) && (!found)) {
    if(strcmp(id_str, shiptype[i].id) == 0)
      found = TRUE;
    else
      i++;
  }

  if(found)
     return(i);
  else
    return(-1);
}

void load_fleet(char *filename, char *section)
{
  int i, count, ship_index;
  char slot_str[8];
  const char *slot_id, *title;

  init_fleet();

  if (filename) set_config_file(filename);
  count = get_config_int(section, "Size", 0);
  title = get_config_string(section, "Title", "");
  sprintf(fleet_title, title);

  for(i = 0; i < count; i++) {
    sprintf(slot_str, "Slot%d", i);
    slot_id = get_config_string(section, slot_str, "?????");
    ship_index = ship_idtoindex(slot_id);
    if(ship_index >= 0)
      select_fleet_slot(i, ship_index);
  }

  fleet_size = count;
}

char *fleetListboxGetter(int index, int *list_size)
{
  if(index < 0) {
    *list_size = MAX_FLEET_SIZE;
    return NULL;
  } else
    return fleet_name[index];
}

void load_ship_data(int index) {
	if(shiptype[index].dat != NULL)
		return;

	char fn[19] = "ships/shp";
	strcat(fn, shiptype[index].id);
	strcat(fn, ".dat");

	shiptype[index].dat = new ShipData(fn);
	shiptype[index].dat->type = &shiptype[index];
	return;
	}

ShipRegistration::ShipRegistration(char *id, char *name, 
		Ship *(*getShip)(double sX, double sY, double sAngle, int sCollideFlag, 
		int sRadarColor, ShipData *sData, Control *cntrl)) {
	num_shiptypes += 1;
	shiptype = (shiptype_type*)realloc(shiptype, num_shiptypes * sizeof(shiptype_type));
	int i = num_shiptypes-1;
	shiptype[i].id = id;
	shiptype[i].name = name;
	shiptype[i].getShip = getShip;
	shiptype[i].dat = NULL;
	shiptype[i].cost = 0;
	return;
	}

void init_ships() {
	int i = num_shiptypes;
  if (i == 0) throw ("No ship data available.\n");
	while (i > 0) {
		i -= 1;
		char fname[80] = "ships/shp";
		strcat(fname, shiptype[i].id);
		strcat(fname, ".dat");
		if (!exists(fname)) {
			memmove(&shiptype[i], &shiptype[num_shiptypes-1], sizeof(shiptype_type));
			num_shiptypes -= 1;
			}
		else {
			strcat(fname, "#SHIP_DAT");
			set_config_file(fname);
			shiptype[i].cost = get_config_int("Ship", "Cost", -1);
			}
		}
	return;
	}

void free_ships(int ship1, int ship2) {
	int i;

	for(i = 0; i < num_shiptypes; i++) {
		if((shiptype[i].dat != NULL) && (i != ship1) && (i != ship2)) {
			delete shiptype[i].dat;
			shiptype[i].dat = NULL;
			}
		}
	}

ShipPanel *select_ship(int player, int index) {
	int    radar_color = RADAR_COLOR_FRIEND;
	double angle, x, y;

	if (player != hero) radar_color = RADAR_COLOR_ENEMY;

	x = (double)(random() % (long)(X_MAX));
	y = (double)(random() % (long)(Y_MAX));
	angle = (double)(random() % 64) * 5.625;

	load_ship_data(index);

	char buffy[64];
	buffy[0] = 0;
	strcat (buffy, "ships/");
	strcat (buffy, shiptype[index].id);
	strcat (buffy, ".ini");
	tw_log_file(buffy);
	tw_unlog_file(buffy);
  
	return(new ShipPanel(
			shiptype[index].getShip(x, y, angle, player, radar_color,
			shiptype[index].dat, control[player]), player));
	}

int tw_sample (SAMPLE *spl, int vol, int pan, int freq) {
	if (sound_on) 
			return play_sample (spl, (vol * sound_volume) >> 8, pan, freq, false);
	else return 0;
	}
