#include <string.h>

#include "../melee.h"

#define   NO_JGMOD
#define   NO_AASTR
#include "../libs.h"

#include "mnet.h"

#if defined NETWORK_BSD

#include <unistd.h>
//#include <dos.h>
//#include <lsck/lsck.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <fcntl.h>
#include <errno.h>

#define SOCKET int
#define INVALID_SOCKET -1
#define get_error() (errno)
#define set_error(a) (errno = a)
#define close_socket(a) close(a)
#define SOCKET_ERROR -1
#define s signed_socket

#elif defined NETWORK_WINSOCK

#include <winalleg.h>
#include "winsock.h"
#define get_error() WSAGetLastError()
#define set_error(a) WSASetLastError(a)
#define close_socket(a) closesocket(a)
#define s unsigned_socket

#endif



extern char dialog_string[20][80];
#define DIALOG_CONNECT_BOX            0
#define DIALOG_CONNECT_TITLE          1
#define DIALOG_CONNECT_ADDRESS        2
#define DIALOG_CONNECT_ADDRESS_BOX    3
#define DIALOG_CONNECT_ADDRESS_EDIT   4
#define DIALOG_CONNECT_PORT           5
#define DIALOG_CONNECT_PORT_BOX       6
#define DIALOG_CONNECT_PORT_EDIT      7
#define DIALOG_CONNECT_OK             8
#define DIALOG_CONNECT_CANCEL         9
static DIALOG connect_dialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        40,  110,  480,  250,  255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_text_proc,       50,  120,  460,  30,   255,  0,    0,    0,       0,    0,    (void *)"Connect to server:" , NULL, NULL },
  { d_text_proc,       50,  150,  460,  30,   255,  0,    0,    0,       0,    0,    (void *)"IP Address" , NULL, NULL },
  { d_box_proc,        48,  178,  464,  34,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_edit_proc,       50,  180,  460,  30,   255,  0,    0,    0,       75,   0,    dialog_string[0], NULL, NULL },
  { d_text_proc,       50,  230,  460,  30,   255,  0,    0,    0,       0,    0,    (void *)"Port #" , NULL, NULL },
  { d_box_proc,        48,  258,  464,  34,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_edit_proc,       50,  260,  460,  30,   255,  0,    0,    0,       75,   0,    dialog_string[1], NULL, NULL },
  { d_button_proc,     50,  300,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Connect", NULL, NULL },
  { d_button_proc,     350, 300,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Abort", NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

static int connect_menu(char **address, int *port) {
	int i = 0;
  set_dialog_color(connect_dialog, pallete_color[0], pallete_color[15]);
	if (*address) strncpy(dialog_string[0], *address, 70);
	if (port) sprintf(dialog_string[1], "%d", *port);
	i = popup_dialog(connect_dialog, DIALOG_CONNECT_ADDRESS_EDIT);
	if (i == DIALOG_CONNECT_CANCEL) return -1;
	*port = atoi(dialog_string[1]);
	*address = strdup(dialog_string[0]);
	return 0;
	}



#ifndef NETWORK_NONE

static int network_status = 0;
#define NETWORK_STATUS_WINSOCK_STARTED 0x01

static void msg (char *) {}

void (* NetTCP::message)(char*) = &msg;

static fd_set read_set, write_set, except_set;
static timeval tmv = {0, 0};
int NetTCP::init() {
#if defined NETWORK_WINSOCK
	if (! (network_status & NETWORK_STATUS_WINSOCK_STARTED)) {
		WSADATA info;
		if (WSAStartup (MAKEWORD(1,1), &info) != 0) {
			message("NetTCP::init: winsock startup failed");
			return -1;
			}
		message ("NetTCP::init: winsock started");
		network_status |= NETWORK_STATUS_WINSOCK_STARTED;
		}
	else message ("NetTCP::init: winsock already started");
#elif defined NETWORK_BSD
#endif
	s = INVALID_SOCKET;
	FD_ZERO(&read_set);
	FD_ZERO(&write_set);
	FD_ZERO(&except_set);
	return 0;
	}

void NetTCP::deinit() {
	message ("NetTCP::deinit: network shut down");
	}


extern char dialog_string[20][80];
static DIALOG port_dialog[] =
{
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)  (d2)  (dp)
  { d_box_proc,        120,  100,  280,  150,  255,  0,    0,    0,          0,    0,    NULL, NULL, NULL },
  { d_text_proc,       140,  110,  240,  25,   255,  0,    0,    0,          0,    0,    (void*)"Enter a port number (1024-65535)", NULL, NULL },
  { d_edit_proc,       180,  140,  160,  25,   255,  0,    0,    0,          5,    0,    dialog_string[0], NULL, NULL },
  { d_button_proc,     160,  170,  200,  30,   255,  0,    0,    D_EXIT,     0,    0,    (void*) "OK", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,          0,    0,    NULL, NULL, NULL }
};
static int get_port_dialog() {
	dialog_string[0][0] = '\0';
	int p = -1;
	while ((p < 1024) || (p > 65535)) {
		popup_dialog(port_dialog, 2);
		p = atoi(dialog_string[0]);
		}
	return p;
	}

void NetTCP::optimize4bandwidth() {
#ifdef NETWORK_WINSOCK
	BOOL tmpbool = false;
	setsockopt ( s, SOL_SOCKET, TCP_NODELAY, (const char *)&tmpbool, sizeof(tmpbool));
#endif
	return;
	}

void NetTCP::optimize4latency() {
#ifdef NETWORK_WINSOCK
	BOOL tmpbool = true;
	setsockopt ( s, SOL_SOCKET, TCP_NODELAY, (const char *)&tmpbool, sizeof(tmpbool));
#endif
	return;
	}

int NetTCP::listen(int port) {
	if (s != INVALID_SOCKET) throw ("NetTCP::listen: socket already active");
	s = socket( AF_INET, SOCK_STREAM, 0);
	if (s == INVALID_SOCKET) {
		message("NetTCP::listen: socket allocation failed");
		return -1;
		}
	message ("NetTCP::listen: socket allocated");
	if (!port) port = get_port_dialog();
	sockaddr_in self;
	self.sin_family = AF_INET;
	self.sin_port = htons(port);
	self.sin_addr.s_addr = 0;
	memset(&(self.sin_zero), 0, 8);
	if (bind (s, (sockaddr *) &self, sizeof(sockaddr_in) ) == -1) {
		char tmp[80];
// is that right for error values? under BSD & winsock?
		sprintf (tmp, "NetTCP::listen: bind to port %d failed", port);
		message (tmp);
		close_socket(s);
		s = INVALID_SOCKET;
		return -2;
		}
	else {
		char tmp[80];
		sprintf (tmp, "NetTCP::listen: socket bound to port", port);
		message (tmp);
		}
	if (::listen(s, 1) == -1) {
		message ("NetTCP::listen: listen failed");
		close_socket(s);
		s = INVALID_SOCKET;
		return -3;
		}
	sockaddr_in other;
#ifdef NETWORK_WINSOCK 
	int tmp;
#else if defined NETWORK_BSD
	unsigned int tmp;
#endif
	SOCKET new_socket;
	while (true) {
//evil
		while (!ready2recv()) if (key[KEY_ESC]) {
			close_socket(s);
			s = INVALID_SOCKET;
			return -4;
			}
		tmp = sizeof(sockaddr_in);
		if ((new_socket = accept(s, (sockaddr *) &other, &tmp)) != INVALID_SOCKET) {
			close_socket(s);
			s = new_socket;
			return 0;
			}
		}
	throw("NetTCP::listen: WTF?");
	return 0;
	}

int NetTCP::connect(char *address, int port) {
	ASSERT(port < 65535);
	if (s != INVALID_SOCKET) throw ("NetTCP::connect: already active");
	if (!address) {
		if (connect_menu(&address, &port)) return -1;
		}
	else address = strdup(address);
	hostent *he = gethostbyname(address);
	free(address);
	if (!he) {
		message("NetTCP::connect: target lookup failed");
		return -2;
		}
	message("NetTCP::connect: target lookup succeeded");
	s = socket( AF_INET, SOCK_STREAM, 0);
	if (s == INVALID_SOCKET) {
		message("NetTCP::connect: socket allocation failed");
		return -3;
		}
	message ("NetTCP::connect: socket allocated");

	sockaddr_in other;

  memset(&other,0,sizeof(other));
  memcpy((char *)&other.sin_addr, he->h_addr, he->h_length);
  other.sin_family = he->h_addrtype;
  other.sin_port = htons((unsigned short) port);

	while (::connect(s, (struct sockaddr *)&other, sizeof(other)) == SOCKET_ERROR) {
		if (key[KEY_ESC]) {
			close_socket(s);
			s = INVALID_SOCKET;
			return -4;
			}
		}
	return 0;
	}

int NetTCP::disconnect() {
	close_socket(s);
	return 0;
	}

int NetTCP::ready2send() {
	int r;
	tmv.tv_sec = 0;
	tmv.tv_usec = 0;
	FD_SET ( s, &write_set);
	r = select (0, &read_set, &write_set, &except_set, &tmv);
	FD_CLR ( s, &write_set);
	return r;
	}
int NetTCP::ready2recv() {
	int r;
	tmv.tv_sec = 0;
	tmv.tv_usec = 0;
	FD_SET ( s, &read_set);
	r = select (0, &read_set, &write_set, &except_set, &tmv);
	FD_CLR ( s, &read_set);
	return r;
	}
int NetTCP::send(int size, const void *data) {
	int sofar = 0;
	while (sofar < size) {
		int tmp = ::send(s, ((char*) data) + sofar, size - sofar, 0);
		if (tmp > 0) sofar += tmp;
		}
	return sofar;
	}
int NetTCP::recv(int min, int max, void *data) {
	int sofar = 0;
	while (sofar < min) {
		int tmp = ::recv(s, ((char*) data) + sofar, max - sofar, 0);
		if (tmp > 0) sofar += tmp;
		}
	return sofar;
	}


#else

int NetTCP::init() {
	return 0;
	}
void NetTCP::deinit() {
	}
int NetTCP::listen(int port) {
	alert("Networking is disabled (compile-time)", "in this version of TimeWarp", NULL, "Abort", NULL, 'a', 0);	
	return -1;
	}
int NetTCP::connect(char *address, int port) {
	alert("Networking is disabled (compile-time)", "in this version of TimeWarp", NULL, "Abort", NULL, 'a', 0);	
	return -1;
	}
int NetTCP::disconnect() {
	return 0;
	}
int NetTCP::ready2send() {
	return 0;
	}
int NetTCP::ready2recv() {
	return 0;
	}
int NetTCP::send(int size, const void *data) {
	return 0;
	}
int NetTCP::recv(int min, int max, void *data) {
	return 0;
	}
void NetTCP::optimize4bandwidth() {
	return;
	}
void NetTCP::optimize4latency() {
	return;
	}


#endif

#ifdef get_error
#undef get_error
#endif
#ifdef set_error
#undef set_error
#endif
#ifdef close_socket
#undef close_socket
#endif
#ifdef s
#undef s
#endif