#include "../ship.h"

class DaktaklakpakMine;

class DaktaklakpakVivisector : public Ship {

  int          weaponFrames;
  int 	       drillFrames;
  int          weaponDamage;
  int          damageFrameAmount;
  int          drillDamagePerDamageFrame;
  int          damageFrameLeft;
  int          drillDamageLeft;
  int          latched;
  Ship         *grabbed;
  double       grabangle;
  double       grabdistance;
  double       grabshipangle;
  
  double       specialLaunch;
  double       specialRange;
  double       specialVelocity;
  int          specialDamage;
  int          specialArmour;
  int          specialArming;
  DaktaklakpakMine **weaponObject;

  public:
  DaktaklakpakVivisector(double ox, double oy, double shipAngle,
    int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl);

  virtual int activate_weapon();
  virtual int activate_special();
  virtual void calculate();
  virtual int canCollide(SpaceObject *other);
  virtual void animate(Frame *space);
  virtual void inflict_damage(SpaceObject *other);
  
  int numMines;
  int maxMines;
};

class DaktaklakpakMine : public AnimatedShot {

  double       missileVelocity;
  double       missileRange;
  int          missileDamage;
  int          missileArmour;
  int          mineArming;
  int          mineactive;
  double       grabangle;
  double       grabdistance;
  DaktaklakpakVivisector *creator;

  public:
  DaktaklakpakMine(double ox,double oy,double ov, double oangle, int odamage, int oarmour,
    DaktaklakpakVivisector *oship, SpaceSprite *osprite, int ofcount, int ofsize, double misv, double misr,
    int misd, int misa,int misaf);

  virtual void calculate();

};

DaktaklakpakVivisector::DaktaklakpakVivisector(double ox, double oy, double shipAngle,
  int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl) :
  Ship(ox, oy, shipAngle, shipCollideFlag, shipRadarColor, shipData, cntrl)

{
  weaponFrames = get_config_int("Weapon", "Frames", 0);
  drillFrames  = 0;
  weaponDamage   = get_config_int("Weapon", "Damage", 0);

  specialRange    = scale_range(get_config_float("Special", "Range", 0));
  specialVelocity = scale_velocity(get_config_float("Special", "Velocity", 0));
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
  specialArming   = get_config_int("Special","Arming",0);
  specialLaunch   = scale_velocity(get_config_int("Special","Launch",0));
  latched         = FALSE;
  grabbed         = NULL;



  numMines=0;
  maxMines=8;
  weaponObject = new DaktaklakpakMine*[maxMines];
  for (int i = 0; i < maxMines; i += 1) {
    weaponObject[i] = NULL;
		}

}

int DaktaklakpakVivisector::activate_weapon()
{
  if (drillFrames > 0)
    return(FALSE);
  else
    {  drillFrames = weaponFrames;
       return(TRUE);
  }
}

int DaktaklakpakVivisector::activate_special()
{
	if (numMines == maxMines) {
		weaponObject[0]->state = 0;
		numMines -= 1;
		for (int i = 0; i < numMines; i += 1) {
			weaponObject[i] = weaponObject[i + 1];
			}
		weaponObject[numMines] = NULL;
		}
	weaponObject[numMines] = new DaktaklakpakMine(0.0, -(h / 2.0),specialLaunch, (angle + 180),
	   specialDamage, specialArmour, this, data->spriteSpecial, 8, 60, specialVelocity,specialRange,
	   specialDamage, specialArmour, specialArming);
	spaceFrame->addSpaceObject(weaponObject[numMines]);
	numMines += 1;
	return(TRUE);
}

void DaktaklakpakVivisector::calculate()
{
   if(drillFrames > 0) {
     drillFrames-= frame_time;
     if ((drillFrames <= 0) && (!latched)) {
       stop_sample(data->sampleWeapon[0]);
       tw_sample(data->sampleWeapon[0]);
      }
    }
   else latched = FALSE;
   if (grabbed != NULL)
     if (!(grabbed ->exists())){
       latched = FALSE;
       grabbed = NULL;
     }
   if (latched) {
      damageFrameLeft-=frame_time;
      if (damageFrameLeft <=0) {
        damageFrameLeft += damageFrameAmount;
        if (drillDamageLeft < drillDamagePerDamageFrame)
          grabbed->damage += drillDamageLeft;
        else {
          grabbed->damage += drillDamagePerDamageFrame;
          drillDamageLeft -= drillDamagePerDamageFrame; }
        grabbed->handle_damage(this); }
      grabangle = (grabbed->get_angle() - grabshipangle) + grabangle;
      angle=grabangle;
      grabshipangle = grabbed->get_angle();
      nextkeys &= ~(KEYFLAG_LEFT | KEYFLAG_RIGHT | KEYFLAG_THRUST);

      x = grabbed->normal_x()-((cos(grabangle * ANGLE_RATIO)) * grabdistance);
      y = grabbed->normal_y()-((sin(grabangle * ANGLE_RATIO)) * grabdistance);
   }
   int j = 0;
   for (int i = 0; i < numMines; i += 1) {
    weaponObject[i-j] = weaponObject[i];
    if (!weaponObject[i]->exists()) j += 1;
      if (j) weaponObject[i] = NULL;
    }
    numMines -= j;

   Ship::calculate();
}
int DaktaklakpakVivisector::canCollide(SpaceObject *other)
{
  if ((latched) && (grabbed!=NULL) && (grabbed->exists())) {
    if (grabbed == other)
      return (FALSE);
		}
  return (Ship::canCollide(other));
}
 
void DaktaklakpakVivisector::animate(Frame *space)
{
  if(phase_count <  PHASE_MAX)
    return;
  if(drillFrames > 0)
    data->spriteWeapon->animate((int)(corner_x()), (int)(corner_y()), sprite_index, space_zoom, space);
  else
    sprite->animate((int)(corner_x()), (int)(corner_y()), sprite_index, space_zoom, space);

}


void DaktaklakpakVivisector::inflict_damage(SpaceObject *other)
{
  if (drillFrames > 0)
    if (!latched)
      if ((!(isAlly(other))) &&
        ((other->getID() & SPACE_MASK) == SPACE_SHIP)) {
          latched=TRUE;
          grabbed= (Ship *) other;
          grabangle= (trajectory_angle(other) );
          grabdistance = (distance(other) * 1.1);
          grabshipangle = (other->get_angle());
          drillDamageLeft = weaponDamage;
          stop_sample(data->sampleExtra[1]);
          tw_sample(data->sampleExtra[1]);
          if ((drillFrames / frame_time)< weaponDamage) {
            drillDamagePerDamageFrame = (weaponDamage/drillFrames)
              + ((weaponDamage % drillFrames) > 0.00001);
            damageFrameLeft = 1;
            damageFrameAmount = 1;
          } else {
            damageFrameAmount = (drillFrames/weaponDamage);
            damageFrameLeft = damageFrameAmount;
            drillDamagePerDamageFrame = 1;
            }
    }
  Ship::inflict_damage(other);
}

DaktaklakpakMine::DaktaklakpakMine(double ox,double oy,double ov, double oangle, int odamage,
  int oarmour,DaktaklakpakVivisector *oship, SpaceSprite *osprite, int ofcount, int ofsize, double misv,
  double misr, int misd, int misa,int misaf) :
  AnimatedShot(ox, oy, oangle, ov, odamage, -1.0, oarmour, oship, oship,
    osprite, ofcount, ofsize)

{
  missileVelocity = misv;
  missileRange = misr;
  missileDamage =misd;
  missileArmour = misa;
  mineArming = misaf;
  mineactive = FALSE;
  creator = oship;
}

void DaktaklakpakMine::calculate()

{
  AnimatedShot::calculate();
  if (!mineactive) {
    mineArming -= frame_time;
    if (mineArming <= 0) {
      mineactive = TRUE;
      v = 0;
      vx = 0;
      vy = 0;
      }
    }
  else {
    int locked = FALSE;
    SpaceObject *o, *t = NULL;
    double oldrange = 999999;
    Query a;
    for (a.begin(this, bit(LAYER_SHIPS),(missileRange *.9));
           a.current; a.next()) {
		o = a.currento;
		if (!o->isAlly(this) && (distance(o) < oldrange) && (o->allyFlag() != -1)) {
			t = o;
			oldrange = distance(o);
			}
		}
    if (t) {
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      stop_sample(creator->data->sampleExtra[0]);
      tw_sample(creator->data->sampleExtra[0]);
      destroy();
    }
  }
}

Ship *getDaktaklakpakVivisector(double sX, double sY, double sAngle,
  int sCollideFlag, int sRadarColor, ShipData *sData, Control *cntrl)

{
  return(new DaktaklakpakVivisector(
    sX, sY, sAngle, sCollideFlag, sRadarColor, sData, cntrl));
}

static ShipRegistration ignore_me(
	"dakvi",
	"Daktaklakpak Vivisector",
	getDaktaklakpakVivisector
	);
