
#include "../ship.h"

class DoogConstructor : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  public:
  DoogConstructor(double ox, double oy, double shipAngle,
    int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl);

  virtual int activate_weapon();
  virtual int activate_special();
};
DoogConstructor::DoogConstructor(double ox, double oy, double shipAngle,
  int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl) :
  Ship(ox, oy, shipAngle, shipCollideFlag, shipRadarColor, shipData, cntrl)

{
  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
}

int DoogConstructor::activate_weapon()
{
	double a;
	if (target) {
		double r = distance(target);
		r = r / weaponVelocity;
		double x = min_delta( normal_x() , target->normal_x() - 
				(get_vx() - target->get_vx()) * r, X_MAX);
		double y = min_delta( normal_y() , target->normal_y() - 
				(get_vy() - target->get_vy()) * r, Y_MAX);
		a = atan2(y, x) * 180 / PI - 180;
		}
	else a = angle;
  spaceFrame->addSpaceObject(new Missile(0.0, 0.0, a , weaponVelocity,
    weaponDamage, weaponRange, weaponArmour, this, this, data->spriteWeapon));
  return(TRUE);
}

int DoogConstructor::activate_special()
{
  int regen;

  if (crew >= crew_max)
    regen = FALSE;
  else {
    crew++;
    regen = TRUE;}
  return (regen);
}

Ship *getDoogConstructor(double sX, double sY, double sAngle,
  int sCollideFlag, int sRadarColor, ShipData *sData, Control *cntrl)
{
  return(new DoogConstructor(
    sX, sY, sAngle, sCollideFlag, sRadarColor, sData, cntrl));
}

static ShipRegistration ignore_me(
	"dooco",
	"Doog Constructor",
	getDoogConstructor
	);
