#include "../ship.h"

class KtangMine;

class KtangCrippler : public Ship {

  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;

  double       specialLaunch;
  double       specialRange;
  double       specialVelocity;
  int          specialDamage;
  int          specialArmour;
  int          specialArming;
  KtangMine    **weaponObject;

  public:
  KtangCrippler(double ox, double oy, double shipAngle,
    int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl);

  virtual int activate_weapon();
  virtual int activate_special();
  virtual void calculate();

  int numMines;
  int maxMines;
};

class KtangMine : public Shot {

  double       missileVelocity;
  double       missileRange;
  int          missileDamage;
  int          missileArmour;
  int          mineArming;
  int          mineactive;
  double       grabangle;
  double       grabdistance;
  KtangCrippler *creator;

  public:
  KtangMine(double ox,double oy,double ov, double oangle, int odamage, int oarmour,
    KtangCrippler *oship, SpaceSprite *osprite, double misv, double misr,
    int misd, int misa,int misaf);

  virtual void calculate();

};

KtangCrippler::KtangCrippler(double ox, double oy, double shipAngle,
  int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl) :
  Ship(ox, oy, shipAngle, shipCollideFlag, shipRadarColor, shipData, cntrl)

{
  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);

  specialRange    = scale_range(get_config_float("Special", "Range", 0));
  specialVelocity = scale_velocity(get_config_float("Special", "Velocity", 0));
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
  specialArming   = get_config_int("Special","Arming",0);
  specialLaunch   = scale_velocity(get_config_int("Special","Launch",0));

  numMines=0;
  maxMines=8;
  weaponObject = new KtangMine*[maxMines];
  for (int i = 0; i < maxMines; i += 1) {
    weaponObject[i] = NULL;
		}
}

int KtangCrippler::activate_weapon()
{
  spaceFrame->addSpaceObject(new Shot(23.0, 75,
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, this, data->spriteWeapon,1));
  spaceFrame->addSpaceObject(new Shot(-23.0, 75,
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, this, data->spriteWeapon,1));
  spaceFrame->addSpaceObject(new Shot(26.0, 60,
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, this, data->spriteWeapon,1));
  spaceFrame->addSpaceObject(new Shot(-26.0, 60,
    angle, weaponVelocity, weaponDamage, weaponRange, weaponArmour,
    this, this, data->spriteWeapon,1));
  return (TRUE);
}

int KtangCrippler::activate_special()
{
	if (numMines == maxMines) {
		weaponObject[0]->state = 0;
		numMines -= 1;
		for (int i = 0; i < numMines; i += 1) {
			weaponObject[i] = weaponObject[i + 1];
			}
		weaponObject[numMines] = NULL;
		}
	weaponObject[numMines] = new KtangMine(0.0, -(h / 2.0),specialLaunch, (angle + 180),
	   4, 4, this, data->spriteSpecial,specialVelocity,specialRange,
	   specialDamage, specialArmour, specialArming);
	spaceFrame->addSpaceObject(weaponObject[numMines]);
	numMines += 1;
	return(TRUE);
}

void KtangCrippler::calculate()
{
  int j = 0;
  for (int i = 0; i < numMines; i += 1) {
    weaponObject[i-j] = weaponObject[i];
    if (!weaponObject[i]->exists()) j += 1;
    if (j) weaponObject[i] = NULL;
    }
  numMines -= j;
  Ship::calculate();
}

KtangMine::KtangMine(double ox,double oy,double ov, double oangle, int odamage,
  int oarmour,KtangCrippler *oship, SpaceSprite *osprite, double misv,
  double misr, int misd, int misa,int misaf) :
  Shot(ox, oy, oangle, ov, odamage, -1.0, oarmour, oship, oship,
    osprite)

{
  missileVelocity = misv;
  missileRange = misr;
  missileDamage =misd;
  missileArmour = misa;
  mineArming = misaf;
  mineactive = FALSE;
  creator = oship;
}

void KtangMine::calculate()

{
  Shot::calculate();
  if (!mineactive) {
    mineArming -= frame_time;
    if (mineArming <= 0) {
      mineactive = TRUE;
      v = 0;
      vx = 0;
      vy = 0;
      }
    }
  else {
    int locked = FALSE;
    SpaceObject *o, *t = NULL;
    double oldrange = 999999;
    Query a;
    for (a.begin(this, bit(LAYER_SHIPS),(missileRange *.9));
           a.current; a.next()) {
		o = a.currento;
		if (!o->isAlly(this) && (distance(o) < oldrange) && (o->allyFlag() != -1)) {
			t = o;
			oldrange = distance(o);
			}
		}
    if (t) {
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)+5),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)+15),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)+25),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)+35),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)-5),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)-15),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)-25),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      spaceFrame->addSpaceObject(new Missile(0,0,(trajectory_angle(t)-35),
        missileVelocity,missileDamage,missileRange,missileArmour,creator,
        this,creator->data->spriteExtra));
      stop_sample(creator->data->sampleExtra[0]);
      tw_sample(creator->data->sampleExtra[0]);
      state=0;
    }
  }
}

Ship *getKtangCrippler(double sX, double sY, double sAngle,
  int sCollideFlag, int sRadarColor, ShipData *sData, Control *cntrl)

{
  return(new KtangCrippler(
    sX, sY, sAngle, sCollideFlag, sRadarColor, sData, cntrl));
}

static ShipRegistration ignore_me(
	"ktacr",
	"K'tang Crippler",
	getKtangCrippler
	);
