
#include "../ship.h"

#include "../frame.h"

class PhylxanMine;

class PhylxanGriffon : public Ship {
  double       weaponRange;
  double       weaponVelocity;
  int          weaponDamage;
  int          weaponArmour;
  int          weaponoffset;

  double       specialRange;
  double       specialVelocity;
  int          specialDamage;
  int          specialArmour;
  int          specialTimer;
  double       specialRadius;
  int          numMines;
  int          maxMines;
  double       specialSeek;
  double       specialVSeek;

  PhylxanMine  **weaponObject;

  public:
  PhylxanGriffon(double ox, double oy, double shipAngle,
    int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl);

  protected:
  virtual int activate_weapon();
  virtual int activate_special();
};

class PhylxanMine : public AnimatedShot {

  double       MineRange;
  int          MineTimer;
  double       MineRadius;
  int          MineMoving;
  double       MineSeek;
  double       MineSeekVel;

  public:
  PhylxanMine(double ox, double oy,double ov, double oangle, int odamage,
    int oarmour, Ship *oship, SpaceSprite *osprite, int ofcount, int ofsize,
    double miner, int minet, double minera, double mines, double minesv);

  virtual void calculate();
  virtual void inflict_damage(SpaceObject *other);
};

PhylxanGriffon::PhylxanGriffon(double ox, double oy, double shipAngle,
  int shipCollideFlag, int shipRadarColor, ShipData *shipData, Control *cntrl) :
  Ship(ox, oy, shipAngle, shipCollideFlag, shipRadarColor, shipData, cntrl)
{

  weaponRange    = scale_range(get_config_float("Weapon", "Range", 0));
  weaponVelocity = scale_velocity(get_config_float("Weapon", "Velocity", 0));
  weaponDamage   = get_config_int("Weapon", "Damage", 0);
  weaponArmour   = get_config_int("Weapon", "Armour", 0);
  weaponoffset   = 0;
  specialRange    = scale_range(get_config_float("Special", "Range", 0));
  specialVelocity = scale_velocity(get_config_float("Special", "Velocity", 0));
  specialDamage   = get_config_int("Special", "Damage", 0);
  specialArmour   = get_config_int("Special", "Armour", 0);
  specialTimer    = get_config_int("Special","Timer", 0);
  specialRadius   = scale_range(get_config_float("Special", "Radius", 0));
  specialSeek     = scale_range(get_config_float("Special", "Seek", 0));
  specialVSeek    = scale_velocity(get_config_float("Special", "VelSeek", 0));
  numMines        = 0;
  maxMines        = 3;
  weaponObject = new PhylxanMine*[maxMines];
  for (int i = 0; i < maxMines; i += 1) {
    weaponObject[i] = NULL;
		}

}

int PhylxanGriffon::activate_weapon()
{
  weaponoffset++;
  if (weaponoffset > 3)
    weaponoffset = 0;

  spaceFrame->addSpaceObject(new Missile((width()/4)+(weaponoffset*4),
    (height()*.25),angle, weaponVelocity, weaponDamage,
    weaponRange, weaponArmour,this, this, data->spriteWeapon));
  spaceFrame->addSpaceObject(new Missile((-width()/4)-(weaponoffset*4),
    (height()*.25),angle, weaponVelocity, weaponDamage,
    weaponRange, weaponArmour,this, this, data->spriteWeapon));
  return(TRUE);
}

int PhylxanGriffon::activate_special()
{
	if (numMines == maxMines) {
		weaponObject[0]->state = 0;
		numMines -= 1;
		for (int i = 0; i < numMines; i += 1) {
			weaponObject[i] = weaponObject[i + 1];
			}
		weaponObject[numMines] = NULL;
		}
        weaponObject[numMines] = new PhylxanMine(0.0, -(h / 2.0),specialVelocity, (angle + 180),
	   specialDamage, specialArmour, this, data->spriteSpecial, 32, 20, specialRange,
	   specialTimer, specialRadius, specialSeek, specialVSeek);
	spaceFrame->addSpaceObject(weaponObject[numMines]);
	numMines += 1;
	return(TRUE);
}

PhylxanMine::PhylxanMine(double ox,double oy,double ov, double oangle, int odamage, int oarmour,
    Ship *oship, SpaceSprite *osprite, int ofcount, int ofsize, double miner,
    int minet, double minera, double mines, double minesv) :
    AnimatedShot(ox, oy, oangle, ov, odamage, -1.0, oarmour, oship, oship,
      osprite, ofcount, ofsize)

{
  MineMoving = TRUE;
  MineRange = miner;
  MineTimer = minet;
  MineRadius = minera;
  MineSeek = mines;
  MineSeekVel = minesv;
}

void PhylxanMine::calculate()

{
  int chance;
  AnimatedShot::calculate();
  if (MineMoving) {
    MineRange -= frame_time;
    if (MineRange <= 0) {
      MineMoving = FALSE;
      AnimatedShot::stop();
      }
    }
  Query a;
  Shot *o,*f = NULL;
  SpaceObject *t;
  double r=99999;
  int Seek=FALSE;

  for (a.begin(this, bit(LAYER_SHOTS),MineRadius);
           a.current; a.next()) {
                if (a.currento->isShot()) {
                o = (Shot *) a.currento;
		if ((distance(o) < MineRadius) && (!o->ship->isAlly(ship))
                  && (o->isHomingMissile()))
                        ((HomingMissile *) o)->target = this;
                 }
           }
  for (a.begin(this, bit(LAYER_SHOTS),MineSeek);
         a.current; a.next()) {
           if (a.currento->isShot())
	     if ((distance(a.current) < r) && (!a.current->isAlly(this)) &&
	       (a.current->exists())) {
	       f = (Shot *) a.currento;
	       r = distance(f);
               Seek = TRUE;
	                 }
               }
  if (Seek && (!MineMoving)) {
	angle = trajectory_angle(f);
        r = r / MineSeekVel;
	double x = min_delta( normal_x() , f->normal_x() -
			(0 - f->get_vx()) * r, X_MAX);
	double y = min_delta( normal_y() , f->normal_y() -
			(0 - f->get_vy()) * r, Y_MAX);
	double ang1 = atan2(y, x) * 180 / PI - 180;
        double ang2 = trajectory_angle(f);
        if (((ang1 - ang2) > 178) || ((ang2 - ang1) > 178))
          angle = ang2;
        else angle = ang1;
	v = MineSeekVel;
        vx = (MineSeekVel * cos(angle * ANGLE_RATIO));
        vy = (MineSeekVel * sin(angle * ANGLE_RATIO));
        }
  if ((!Seek) && (!MineMoving))
    AnimatedShot::stop();
  MineTimer -= frame_time;
  if (MineTimer < 0)
    state = 0;
}

void PhylxanMine::inflict_damage(SpaceObject *other) {
  if (other->isShip())
     damage_factor = 0;
  AnimatedShot::inflict_damage(other);
	return;
}

Ship *getPhylxanGriffon(double sX, double sY, double sAngle,
  int sCollideFlag, int sRadarColor, ShipData *sData, Control *cntrl)
{
  return(new PhylxanGriffon(
    sX, sY, sAngle, sCollideFlag, sRadarColor, sData, cntrl));
}

static ShipRegistration ignore_me(
  "phygr",
  "Phylxan Griffon",
  getPhylxanGriffon
	);
