#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <allegro.h>

int NUM_ASTEROIDS = 5;
int  GFX_TIMEWARP =  
#if defined _DEBUG
GFX_DIRECTX_WIN
#else
GFX_AUTODETECT
#endif
//GFX_AUTODETECT
//GFX_DIRECTX_WIN
//GFX_DIRECTX_SOFT
//GFX_DIRECTX_ACCEL
//GFX_DIRECTX_SAFE
//GFX_GDI
//GFX_SAFE
//GFX_DIRECTX_OVL
;
#define TW_SOUND_CHANNELS 16
#define TW_MUSIC_CHANNELS 16
static char tw_version_string[512];
const char *tw_version() {
	sprintf(tw_version_string, "%s", __DATE__);
	return tw_version_string;
	}

#include "melee.h"
#include "libs.h"
#include "scp.h"

#include "frame.h"

#include "melee/mview.h"
#include "melee/mcontrol.h"
#include "melee/mnet.h"
#include "melee/mmain.h"
#include "melee/mcbodies.h"


#define SCPGUI_MUSIC   0
#define SCPGUI_TITLE   1

#define TITLE_DIALOG_BOX    0
#define TITLE_DIALOG_EDIT   1
#define TITLE_DIALOG_OK     2
#define TITLE_DIALOG_CANCEL 3

int compatible_soundcard = FALSE;
int gamma_correction = 0;
int sound_volume = 255;
int music_volume = 255;
int sound_on = true;
int music_on = true;

DATAFILE *scp;

FILE *debug_file;

void showTitle();
void change_options();
void change_teams();
void init_video();
void init_sound();
void init_gamma();

int update_gamma(void *dp3, int val);
int  getKey();

#define MAIN_DIALOG_BOX               0
#define MAIN_DIALOG_MELEE             1
#define MAIN_DIALOG_MELEE_EXTENDED    2
#define MAIN_DIALOG_TEAMS             3
#define MAIN_DIALOG_OPTIONS           4
#define MAIN_DIALOG_HELP              5
#define MAIN_DIALOG_EXIT              6

DIALOG mainDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_shadow_box_proc, 40,  40,   110,  215,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_button_proc,     45,  45,   100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Melee" , NULL, NULL },
  { d_button_proc,     45,  80,   100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Melee 2" , NULL, NULL },
  { d_button_proc,     45,  115,  100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Teams" , NULL, NULL },
  { d_button_proc,     45,  150,  100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Options", NULL, NULL },
  { d_button_proc,     45,  185,  100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Help", NULL, NULL },
  { d_button_proc,     45,  220,  100,   30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Exit", NULL, NULL },
  { NULL,              0,   0,    0,     0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

#define MELEE_EX_DIALOG_BOX         0
#define MELEE_EX_DIALOG_NORMAL      1
#define MELEE_EX_DIALOG_RECORD      2
#define MELEE_EX_DIALOG_PLAYBACK    3
#define MELEE_EX_DIALOG_NET1_SERVER 4
#define MELEE_EX_DIALOG_NET1_CLIENT 5
#define MELEE_EX_DIALOG_EXIT        6
DIALOG melee_ex_dialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_shadow_box_proc, 40,  30,   180,  250,  255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_button_proc,     50,  40,   160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Normal Melee" , NULL, NULL },
  { d_button_proc,     50,  80,   160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Record Demo" , NULL, NULL },
  { d_button_proc,     50,  120,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Playback Demo" , NULL, NULL },
  { d_button_proc,     50,  160,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Net1.0: Server", NULL, NULL },
  { d_button_proc,     50,  200,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Net1.0: Client", NULL, NULL },
  { d_button_proc,     50,  240,  160,  30,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main Menu", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

static int old_x = -1, old_y = -1, old_z = -1;
static void tw_error(char* message) {
	if (old_z != -1) {
		alert ("Error:", message, "", "Exit", NULL, ' ', '\n');
		}
  else allegro_message("Error: %s\n", message);
	allegro_exit();
	exit(42);
	}

void melee_ex(int i = -1) {
  set_dialog_color(melee_ex_dialog, pallete_color[0], pallete_color[15]);
	if (i == -1) {
		i = popup_dialog ( melee_ex_dialog, MELEE_EX_DIALOG_NORMAL );
		switch (i) {
			case MELEE_EX_DIALOG_NORMAL: i = MELEE_NORMAL; break;
			case MELEE_EX_DIALOG_RECORD: i = MELEE_RECORD; break;
			case MELEE_EX_DIALOG_PLAYBACK: i = MELEE_PLAYBACK; break;
			case MELEE_EX_DIALOG_NET1_SERVER: i = MELEE_NET1_SERVER; break;
			case MELEE_EX_DIALOG_NET1_CLIENT: i = MELEE_NET1_CLIENT; break;
			default: i = -1; break;
			}
		}
	if (i >= 0) {
		set_config_file("scp.ini");
		stop_mod();
    unload_datafile(scp);
		font = desktop_font;
		clear(screen);
		try {
			play_melee(i);
			}
		catch (char *string) {
			tw_error(string);
			}
		catch (...) {
			tw_error("unrecognized exception type");
			}
		palette_color[0] = 0;
		scp = load_datafile("scpgui.dat"); //loading all data again
		font = (FONT *)(scppal[SCPPAL_FONT].dat);
    play_mod((JGMOD *)(scp[SCPGUI_MUSIC].dat), TRUE);
		showTitle();
		}
	return;
	}

char title_str[80];

DIALOG titleDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        180,  210,  280,  60,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_edit_proc,       190,  220,  260,  10,   255,  0,    0,    0,       80,   0,    title_str, NULL, NULL },
  { d_button_proc,     255,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     325,  240,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

char dialog_string[20][80];

#define MAX_PLAYERS 8
#define MAX_CONFIGURATIONS 4
char *playerListboxGetter(int index, int *list_size) ;
char *controlListboxGetter(int index, int *list_size) ;
char *viewListboxGetter(int index, int *list_size) ;


char remark[80];

FONT *desktop_font;

////  variables
int    mainRet = 0, shipRet = 0, keyRet = 0, fleetRet = 0, optionsRet= 0;

char old_path[256];

int player_type[MAX_PLAYERS];
int player_config[MAX_PLAYERS];

Control *load_player(int i) {
	char tmp[32];
	Control *r = NULL;
	sprintf (tmp, "Config%d", player_config[i]);
	r = getController(player_type[i], tmp, i);
	if (r) r->load("scp.ini", tmp);
	return r;
	}

int main(int argc, char *argv[]) {
  int    mainLoop;
	int i;
	try {
		allegro_init();
		install_timer();
		install_keyboard();
		install_mouse();

		srand(time(NULL));
		set_keyboard_rate(0,0);
		set_config_file("scp.ini");

		color_depth      = get_config_int("SCP", "BitsPerPixel", 16);
		screen_x         = get_config_int("SCP", "ScreenWidth", 640);
		screen_y         = get_config_int("SCP", "ScreenHeight", 480);
		gamma_correction = get_config_int("SCP", "Gamma", 0);
		antia_on         = get_config_int("SCP", "Anti-Aliasing", 1);
		set_view(view2number(get_config_string("SCP", "View", NULL)));

		init_sound();
		init_video();
		init_ships();
		init_fleet();

		set_config_file ("scp.ini");
		for (i = 0; i < MAX_PLAYERS; i += 1) {
			char tmp[32];
			sprintf (tmp, "Player%d", i+1);
			player_type[i] = control2number(get_config_string(tmp, "Type", "Keyboard"));
			player_config[i] = get_config_int (tmp, "Config", i % MAX_CONFIGURATIONS);
			}
		
		desktop_font = font;

		do {
			mainLoop = TRUE;

			gui_fg_color = pallete_color[0];
			gui_bg_color = pallete_color[15];
			set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);

			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			play_mod((JGMOD *)(scp[SCPGUI_MUSIC].dat), TRUE);

			remark[0] = '\0';

			showTitle();
			do {
				set_dialog_color(mainDialog, pallete_color[0], pallete_color[15]);
				mainRet = popup_dialog(mainDialog, MAIN_DIALOG_MELEE);
				switch (mainRet) {
					case MAIN_DIALOG_MELEE:
						melee_ex(MELEE_NORMAL);
						break;
					case MAIN_DIALOG_MELEE_EXTENDED:
						melee_ex();
						break;
					case MAIN_DIALOG_OPTIONS:
						change_options();
						break;
					case MAIN_DIALOG_HELP:
						show_help();
						break;
					case MAIN_DIALOG_TEAMS:
						change_teams();
						break;
					}
				} while((mainLoop) && (mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));

			unload_datafile(scp);

			scp = load_datafile("scpgui.dat"); //loading all data again

			} while((mainRet != MAIN_DIALOG_EXIT) && (mainRet != -1));
		remove_mod();
		remove_sound();
		remove_keyboard();
		remove_mouse();
		remove_timer();
		unload_datafile(scppal);
		}
	catch (char *string) {
		tw_error(string);
		}
	catch (...) {
		tw_error("unknown error type");
		}

	allegro_exit();
	return 0;
	}
END_OF_MAIN();

void showTitle() {
//  blit((BITMAP *)(scp[SCPGUI_TITLE].dat), screen, 0, 0, 0, 0, 640, 480);
	BITMAP *src = (BITMAP *) scp[SCPGUI_TITLE].dat;
	acquire_screen();
	aa_stretch_blit(src, screen, 0, 0, src->w, src->h, 0, 0, screen_x, screen_y);
//	stretch_blit(src, screen, 0, 0, src->w, src->h, 0, 0, screen_x, screen_y);
	release_screen();
	return;
	}

int getKey() {
//  #ifdef _WIN32
//    while(1)
//      for(int i = 0; i < KEY_MAX; i++)
//        if(key[i] != 0) {
//		  return i;
//		}
//  #else
    unsigned i;
    

    while(!keypressed()) poll_keyboard();

    i = 0;
    while((!key[i]) && (i < KEY_MAX)) i++;

    while(keypressed()) poll_keyboard();
  

    return(i);
//  #endif
}

void init_gamma() {
	int i, table[256];
	if (!gamma_correction) return;
	for (i = 0; i < 256; i += 1) {
		table[i] = int(floor(255.5 * pow(i / 255., 1-gamma_correction/300.)));
		}
	if (color_depth != 8) {
		for (i = 0; i < 256; i += 1) {
			int r, g, b;
			b = pallete_color[i];
			if (b == bitmap_mask_color(screen)) continue;
			r = getr(b);
			g = getg(b);
			b = getb(b);
			r = table[r];
			g = table[g];
			b = table[b];
			pallete_color[i] = makecol(r, g, b);
			}
		}
	return;
	}

void init_video() {
	if ((color_depth != old_z) || (screen_x != old_x) || (screen_y != old_y)) {
		set_color_depth(color_depth);
		if ((spaceFrame && (color_depth != old_z)) || 
				set_gfx_mode(GFX_TIMEWARP, screen_x, screen_y, 0, 0)) {
			char buffy[1024];
			sprintf (buffy, "Error switching to graphics mode(%dx%d @ %d bit):", 
					screen_x, screen_y, color_depth);
			if (old_z == -1) {
				strcat(buffy, allegro_error);
				tw_error(buffy);
				}
			screen_x = old_x;
			screen_y = old_y;
			color_depth = old_z;
			set_color_depth(color_depth);
			set_gfx_mode(GFX_TIMEWARP, screen_x, screen_y, 0, 0);
			if (spaceFrame) {
				alert (buffy, "Cannot change color depths during combat", "", "Resume", NULL, ' ', '\n');
				}
			else alert (buffy, allegro_error, "", "Continue", NULL, ' ', '\n');
			}
		old_x = screen_x;
		old_y = screen_y;
		old_z = color_depth;
		}
	scppal = load_datafile("scppal.dat");
	if(!scppal) tw_error("Error loading SCP pallete data\n");
	set_pallete((RGB*)(scppal[SCPPAL_PALLETE].dat));
	if (color_depth == 8) {
		if (!rgb_map) rgb_map = (RGB_MAP*)malloc(1<<15);
		create_rgb_table ( rgb_map, (RGB*)(scppal[SCPPAL_PALLETE].dat), NULL);
		}
//	init_gamma();
	scp = load_datafile("scpgui.dat");
	if(!scp) tw_error("Error loading SCP GUI data\n");
	clear(screen);
	set_dialog_color(titleDialog, pallete_color[0], pallete_color[15]);
	return;
	}

void init_sound() {
	set_config_file("scp.ini");
	sound_volume = get_config_int("SCP", "SoundVolume", sound_volume);
	music_volume = get_config_int("SCP", "MusicVolume", music_volume);
	sound_on = get_config_int("SCP", "SoundOn", sound_on);
	music_on = get_config_int("SCP", "MusicOn", music_on);
	compatible_soundcard = FALSE;
	if (detect_digi_driver(DIGI_AUTODETECT)>=TW_SOUND_CHANNELS + TW_MUSIC_CHANNELS) {
		compatible_soundcard=true;
		reserve_voices(TW_SOUND_CHANNELS + TW_MUSIC_CHANNELS, 0);
		if (install_sound(DIGI_AUTODETECT, MIDI_NONE, "")<0) compatible_soundcard=FALSE;
		install_mod(TW_MUSIC_CHANNELS);
		}
	set_volumes();
	return;
	}

char *numeric_string[] = {"Zero", "One", "Two", "Three", "Four", 
		"Five", "Six", "Seven", "Eight", "Nine", "Ten", "Eleven", 
		"Twelve"};

#define FLEET_DIALOG_FLEETTITLE    0
#define FLEET_DIALOG_FLEETLIST     1
#define FLEET_DIALOG_SHIPLIST      2
#define FLEET_DIALOG_SELECT        3
#define FLEET_DIALOG_CLEAR         4
#define FLEET_DIALOG_PLAYERBOX     5
#define FLEET_DIALOG_PLAYERTEXT    6
#define FLEET_DIALOG_SAVE          7
#define FLEET_DIALOG_LOAD          8
#define FLEET_DIALOG_TITLE         9
#define FLEET_DIALOG_MAIN          10

char fleetPlayer[18];
char fleetTitleString[100];

DIALOG fleetDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_textbox_proc,    10,   10,   160,  60,   255,  0,    0,    0,       0,    0,    fleetTitleString, NULL, NULL },
  { d_list_proc,       10,   80,   240,  380,  255,  0,    0,    D_EXIT,  0,    0,    fleetListboxGetter, NULL, NULL },
  { d_list_proc,       400,  5,    240,  350,  255,  0,    0,    D_EXIT,  0,    0,    shipListboxGetter, NULL, NULL },
  { d_button_proc,     440,  365,  130,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Ship", NULL, NULL },
  { d_button_proc,     440,  420,  130,  40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Clear Slot", NULL, NULL },
  { d_box_proc,        240,  5,    140,  20,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_ctext_proc,      300,  10,   140,  10,   255,  0,    0,    0,       0,    0,    fleetPlayer, NULL, NULL },
  { d_button_proc,     260,  35,   130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Save Fleet", NULL, NULL },
  { d_button_proc,     260,  95,   130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Load Fleet", NULL, NULL },
  { d_button_proc,     260,  155,  130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Fleet Title", NULL, NULL },
  { d_button_proc,     260,  215,  130,  48,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void edit_fleet(int player) {
	char tmp[40];
  char path[80];
  set_dialog_color(fleetDialog, pallete_color[0], pallete_color[15]);
	sprintf (tmp, "Player%d", player+1);
	load_fleet("fleets.ini", tmp);
	sprintf(fleetPlayer, "Player %s Fleet", numeric_string[player+1]);
	do {
		sprintf(title_str, fleet_title);
		sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);

		fleetRet = do_dialog(fleetDialog, FLEET_DIALOG_SHIPLIST);

		if ((fleetRet == FLEET_DIALOG_SELECT) ||
				(fleetRet == FLEET_DIALOG_SHIPLIST)) {
			select_fleet_slot(
					fleetDialog[FLEET_DIALOG_FLEETLIST].d1,
					fleetDialog[FLEET_DIALOG_SHIPLIST].d1);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if ((fleetRet == FLEET_DIALOG_CLEAR) ||
				(fleetRet == FLEET_DIALOG_FLEETLIST)) {
			clear_fleet_slot(fleetDialog[FLEET_DIALOG_FLEETLIST].d1);
			fleetDialog[FLEET_DIALOG_FLEETLIST].d1++;
			}
		if(fleetRet == FLEET_DIALOG_SAVE) {
			font = desktop_font;
			sprintf(path, "fleets/");
			if(file_select("Save Fleet", path, "scf")) save_fleet(path, "Fleet");
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			showTitle();
			}
		if(fleetRet == FLEET_DIALOG_LOAD) {
			font = desktop_font;
			sprintf(path, "fleets/");
			if(file_select("Load Fleet", path, "scf")) load_fleet(path, "Fleet");
			sprintf(title_str, fleet_title);
			sprintf(fleetTitleString, "%s\n%d points", fleet_title, fleet_cost);
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			showTitle();
			}

		if(fleetRet == FLEET_DIALOG_TITLE) {
			font = desktop_font;
			if(do_dialog(titleDialog, TITLE_DIALOG_BOX) == TITLE_DIALOG_OK)
					sprintf(fleet_title, title_str);
			font = (FONT *)(scppal[SCPPAL_FONT].dat);
			}
		} while((fleetRet != FLEET_DIALOG_MAIN) && (fleetRet != -1));
	save_fleet("fleets.ini", tmp);
	showTitle();
	}



#define TEAMS_DIALOG_BOX							0
#define TEAMS_DIALOG_TITLE						1
#define TEAMS_DIALOG_PLAYERLIST				2
#define TEAMS_DIALOG_CONTROLLIST			3
#define TEAMS_DIALOG_SELECTCONTROL		4
#define TEAMS_DIALOG_CONFIG_NUM				5
#define TEAMS_DIALOG_SETUP						6
#define TEAMS_DIALOG_FLEET						7
#define TEAMS_DIALOG_MAINMENU					8

DIALOG teamsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        35,   35,   420,  420,  255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_textbox_proc,    150,  40,   200,  25,   255,  0,    0,    0,       0,    0,    (void *) "Teams Dialog", NULL, NULL },
  { d_list_proc,       40,   70,   240,  160,  255,  0,    0,    D_EXIT,  0,    0,    playerListboxGetter, NULL, NULL },
  { d_list_proc,       290,  70,   160,  160,  255,  0,    0,    D_EXIT,  0,    0,    controlListboxGetter, NULL, NULL },
  { d_button_proc,     80,   280,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Select Controller", NULL, NULL },
  { d_button_proc,     80,   310,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Switch Config #", NULL, NULL },
  { d_button_proc,     80,   340,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Config", NULL, NULL },
  { d_button_proc,     80,   370,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *) "Edit Fleet", NULL, NULL },
  { d_button_proc,     80,   400,  220,  25,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Main Menu", NULL, NULL },
  { NULL,              0,    0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
};

void change_teams()
{
  set_config_file("scp.ini");
  set_dialog_color(teamsDialog, pallete_color[0], pallete_color[15]);
	
	int a;

	teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1 = 0;
	do {
		dialog_string[0][0] = 0;
		sprintf(dialog_string[0], "Config #");

		a = popup_dialog(teamsDialog, 0);
		if((a == TEAMS_DIALOG_SELECTCONTROL) || (a == TEAMS_DIALOG_CONTROLLIST)) {
			player_type[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] = 
					teamsDialog[TEAMS_DIALOG_CONTROLLIST].d1;
			teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1 += 1;

			}
    if ((a == TEAMS_DIALOG_SETUP) || (a == TEAMS_DIALOG_PLAYERLIST)) {
			Control *tmpc = load_player(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			if (tmpc) {
				showTitle();
				tmpc->setup();
				delete tmpc;
				showTitle();
				}
			}
    if (a == TEAMS_DIALOG_CONFIG_NUM) {
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] += 1;
			player_config[teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1] %= MAX_CONFIGURATIONS;
			}
    if (a == TEAMS_DIALOG_FLEET) {
			edit_fleet(teamsDialog[TEAMS_DIALOG_PLAYERLIST].d1);
			showTitle();
			}
		} while((a != TEAMS_DIALOG_MAINMENU) && (fleetRet != -1));
  set_config_file("scp.ini");
	for (int i = 0; i < MAX_PLAYERS; i += 1) {
		sprintf(dialog_string[0], "Player%d", i+1);
		set_config_string (dialog_string[0], "Type", control_name[player_type[i]]);
		set_config_int (dialog_string[0], "Config", player_config[i]);
		}
	return;
	}

char *playerListboxGetter(int index, int *list_size)
{
	static char tmp[80];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = MAX_PLAYERS;
    return NULL;
  } else {
    sprintf(tmp, "Player%d %s %d", index+1, control_name[player_type[index]], player_config[index]);
		ASSERT (strlen(tmp) < 40);
    return tmp;
  }
}
char *controlListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
  if(index < 0) {
    *list_size = num_controls;
    return NULL;
  } else {
    return(control_name[index]);
  }
}

void set_volumes() {
	if (compatible_soundcard) {
		if (music_on) set_mod_volume (music_volume);
		else set_mod_volume (0);
		}
	return;
	}



//////////// "Options Dialog" /////////////


#define NUM_RESOLUTIONS 4
#define NUM_DEPTHS 5
int screen_xs[NUM_RESOLUTIONS] = {640, 800, 1024, 1280};
int screen_ys[NUM_RESOLUTIONS] = {480, 600, 768, 1024};
int screen_zs[NUM_DEPTHS] = {8, 15, 16, 24, 32};

int screen_x = screen_xs[0], screen_y = screen_ys[0];
int view_x, view_y;
int color_depth;

char *depthListboxGetter(int index, int *list_size) {
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = NUM_DEPTHS;
		return NULL;
		} 
	else {
		sprintf (tmp, "%d bits", screen_zs[index]);
		return(tmp);
		}
	}

char *resListboxGetter(int index, int *list_size) {
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = NUM_RESOLUTIONS;
		return NULL;
		} 
	else {
		sprintf (tmp, "%dx%d", screen_xs[index], screen_ys[index]);
		return(tmp);
		}
	}
char *viewListboxGetter(int index, int *list_size) 
{
	static char tmp[40];
	tmp[0] = 0;
	if(index < 0) {
		*list_size = num_views;
		return NULL;
	} else {
		return(view_name[index]);
	}
}

#define OPTIONS_DIALOG_BOX					0
#define OPTIONS_DIALOG_GAMMA_TEXT		1
#define OPTIONS_DIALOG_GAMMA_SLIDER	2
#define OPTIONS_DIALOG_SOUND				3
#define OPTIONS_DIALOG_SOUND_SLIDER	4
#define OPTIONS_DIALOG_MUSIC				5
#define OPTIONS_DIALOG_MUSIC_SLIDER	6
#define OPTIONS_DIALOG_STARS_TEXT		7
#define OPTIONS_DIALOG_STARS_SLIDER	8
#define OPTIONS_DIALOG_AA						9
#define OPTIONS_DIALOG_COLOR_TEXT		10
#define OPTIONS_DIALOG_COLOR				11
#define OPTIONS_DIALOG_RES_TEXT			12	
#define OPTIONS_DIALOG_RES					13	
#define OPTIONS_DIALOG_VIEW_TEXT		14
#define OPTIONS_DIALOG_VIEW					15
#define OPTIONS_DIALOG_OK						16
#define OPTIONS_DIALOG_CANCEL				17
DIALOG optionsDialog[] = {
  // (dialog proc)     (x)   (y)   (w)   (h)   (fg) (bg) (key) (flags)  (d1)  (d2)  (dp)
  { d_box_proc,        30,   50,  460, 315,   255,  0,    0,    0,       0,    0,    NULL, NULL, NULL },
  { d_text_proc,       40,   80,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Gamma Correction", NULL, NULL },
  { d_slider_proc,     205,  80,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  110,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Sound Volume ", NULL, NULL },  
  { d_slider_proc,     205, 110,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  140,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Music Volume ", NULL, NULL },  
  { d_slider_proc,     205, 140,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_text_proc,       40,  170,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Star Depth", NULL, NULL },
  { d_slider_proc,     205, 170,  180,  15,   255,  0,    0,    0,       255,  0,    NULL, NULL, NULL },
  { d_check_proc,      40,  200,  160,  20,   255,  0,    0,    0,       0,    0,    (void *)"Antialiasing ", NULL, NULL },
  { d_text_proc,       40,  240,  120,  20,   255,  0,    0,    0,       0,    0,    (void *)"Color Depth", NULL, NULL },
  { d_list_proc,       40,  255,  120,  90,   255,  0,    0,    0,       0,    0,    depthListboxGetter, NULL, NULL },
  { d_text_proc,       170, 240,  120,  20,   255,  0,    0,    0,       0,    0,    (void *)"Resolution", NULL, NULL },
  { d_list_proc,       170, 255,  120,  90,   255,  0,    0,    0,       0,    0,    resListboxGetter, NULL, NULL },
  { d_text_proc,       300, 240,  180,  20,   255,  0,    0,    0,       0,    0,    (void *)"View", NULL, NULL },
  { d_list_proc,       300, 255,  180,  90,   255,  0,    0,    0,       0,    0,    viewListboxGetter, NULL, NULL },
  { d_button_proc,     400,  80,  80,   40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"OK", NULL, NULL },
  { d_button_proc,     400, 140,  80,   40,   255,  0,    0,    D_EXIT,  0,    0,    (void *)"Cancel", NULL, NULL },
  { NULL,              0,   0,    0,    0,    255,  0,    0,    0,       0,    0,    NULL, NULL, NULL }
	};

void change_options() {
	int i, j, res, depth;
	set_dialog_color(optionsDialog, pallete_color[0], pallete_color[15]);

	set_config_file("scp.ini");
	if (sound_on) optionsDialog[OPTIONS_DIALOG_SOUND].flags = D_SELECTED;
	if (music_on) optionsDialog[OPTIONS_DIALOG_MUSIC].flags = D_SELECTED;
	if (antia_on) optionsDialog[OPTIONS_DIALOG_AA].flags = D_SELECTED;

	optionsDialog[OPTIONS_DIALOG_GAMMA_SLIDER].d2 = gamma_correction;
	optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2 = sound_volume;
	optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2 = music_volume;
	optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2 = get_config_int("SCP", "StarDepth", 192);

	optionsDialog[OPTIONS_DIALOG_VIEW].d1 = view_num;
	depth = 0;
	for (i = 0; i < NUM_DEPTHS; i += 1) if (screen_zs[i] == color_depth) depth = i;
	optionsDialog[OPTIONS_DIALOG_COLOR].d1 = depth;
	res = 0;
	for (i = 0; i < NUM_RESOLUTIONS; i += 1) 
		if ((screen_xs[i] == screen_x) && (screen_ys[i] == screen_y)) res = i;
	optionsDialog[OPTIONS_DIALOG_RES].d1 = res;
 
	optionsRet = popup_dialog(optionsDialog, OPTIONS_DIALOG_OK);

	if (optionsRet == OPTIONS_DIALOG_CANCEL) return;

	if (optionsDialog[OPTIONS_DIALOG_MUSIC].flags==D_SELECTED) music_on = true;
	else music_on = FALSE;
	if (optionsDialog[OPTIONS_DIALOG_SOUND].flags==D_SELECTED) sound_on = true;
	else sound_on=FALSE;

	if (optionsDialog[OPTIONS_DIALOG_AA].flags==D_SELECTED) antia_on=1;
	else antia_on = 0;

	gamma_correction = optionsDialog[OPTIONS_DIALOG_GAMMA_SLIDER].d2;
	i = optionsDialog[OPTIONS_DIALOG_COLOR].d1;
	j = optionsDialog[OPTIONS_DIALOG_RES].d1;
	if ((depth != i) || (res != j)) {
		color_depth = screen_zs[i];
		screen_x = screen_xs[j];
		screen_y = screen_ys[j];
		init_video();
		showTitle();
		}
	
	set_config_file("scp.ini");
	set_config_int("SCP", "BitsPerPixel", color_depth);
	set_config_int("SCP", "ScreenWidth", screen_x);
	set_config_int("SCP", "ScreenHeight", screen_y);
	set_config_int("SCP", "Gamma", gamma_correction);
	set_config_int("SCP", "Anti-Aliasing", antia_on);
	set_view(view2number(view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]));
	set_config_string("SCP", "View", view_name[optionsDialog[OPTIONS_DIALOG_VIEW].d1]);
	sound_volume = optionsDialog[OPTIONS_DIALOG_SOUND_SLIDER].d2;
	music_volume = optionsDialog[OPTIONS_DIALOG_MUSIC_SLIDER].d2;
	if (view) view->set_depth(optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2);
	set_config_int("SCP", "SoundVolume", sound_volume);
	set_config_int("SCP", "MusicVolume", music_volume);
	set_config_int("SCP", "StarDepth", optionsDialog[OPTIONS_DIALOG_STARS_SLIDER].d2);
	if (compatible_soundcard) {
		set_config_int("SCP", "MusicOn", music_on);
		set_config_int("SCP", "SoundOn", sound_on);
		}
	set_volumes();
	return;
	}

#define tw_random_length0 4
#define tw_random_length1 5
static int tw_random_state0[tw_random_length0];
static int tw_random_state1[tw_random_length1];
static int tw_random_index0, tw_random_index1;
static int tw_random_carry;

int tw_random() {
	int i;
	i = tw_random_state0[tw_random_index0] + tw_random_state1[tw_random_index1] + tw_random_carry;
	if (i < 0) {
		tw_random_carry = 1;
		i &= 0x7fffffff;
		}
	else tw_random_carry = 0;
	tw_random_state0[tw_random_index0] ^= i;
	tw_random_state1[tw_random_index1] ^= i;
	if ((tw_random_index0 -= 1) < 0) tw_random_index0 += tw_random_length0;
	if ((tw_random_index1 -= 1) < 0) tw_random_index1 += tw_random_length1;
	return i;
	}

int tw_random_peek() {
	int i;
	i = tw_random_state0[tw_random_index0] + tw_random_state1[tw_random_index1] + tw_random_carry;
	return i & 0x7fffffff;
	}

void tw_random_seed (int s) {
	s = (s << 2) + 2;
	int i;
	for (i = 0; i < 16; i += 1) s = s*(s+1);
	for (i = 0; i < tw_random_length0; i += 1) {
		tw_random_state0[i] = s;
		s = s*(s+1);
		}
	tw_random_index0 = 0;
	for (i = 0; i < tw_random_length1; i += 1) {
		tw_random_state1[i] = s;
		s = s*(s+1);
		}
	tw_random_index1 = 0;
	for (i = 0; i < 32; i += 1) tw_random();
	return;
	}

